////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project ExtIO_FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////
#include "stdafx.h"
#include "GlobalTools.h"

BOOL WINAPI InitHW(char *name, char *model, int& type)
{
	type = 4;	//data returned via the sound card
				//this DLL controls only the frequency 
	strcpy(name,"FiFi-SDR");
	strcpy(model,"OV-Lennestadt");
	if(!myCtrl.GetSafeHwnd())
		{
		AFX_MANAGE_STATE(AfxGetStaticModuleState( )); 
		myCtrl.Create(IDD_EXTIO_DIALOG,NULL);
		if(!myCtrl.FiFiReady) 
			{
			AfxMessageBox("FiFi-SDR not ready");
			return FALSE;
			}
		}

	return TRUE;
}

BOOL WINAPI OpenHW(void)
{
	return TRUE;
}

int WINAPI StartHW(long freq)
{
	SetFiFiFreq(freq);
	return 0;
}

void WINAPI StopHW(void)
{
}

void WINAPI CloseHW(void)
{
	myCtrl.ShowWindow(SW_HIDE);
}

int WINAPI SetHWLO(long LOfreq)
{
	SetFiFiFreq(LOfreq);
	lastFrq=LOfreq;
	return lastFrq;
}

long WINAPI GetHWLO(void)
{
	return lastFrq;
}

long WINAPI GetHWSR(void)
{
	return NULL;
}

long WINAPI GetTune(void)
{
	return lastFrq;
}

void WINAPI GetFilters(int& loCut, int& hiCut, int& pitch)
{
}

char WINAPI GetMode(void)
{
	return NULL;
}

void WINAPI ModeChanged(char mode)
{
}

//this prevent the WARNING LNK4022 (cannot find unique match for symbol "GetStatus")
//too many GetStatus-Routines are defined in the system 
extern "C"
int __stdcall GetStatus(void)
{
return 0; // status not supported by this specific HW,
}


void WINAPI ShowGUI(void)
{
	myCtrl.Show_GUI(SW_SHOW);
}

void WINAPI HideGUI(void)
{
	myCtrl.Show_GUI(SW_HIDE);
}

void WINAPI IFLimitsChanged(long low, long high)
{
}

void WINAPI TuneChanged(long freq)
{
}

void WINAPI SetCallback(void (* Callback)(int, int, float, short *))
{
}

void WINAPI RawDataReady(long samprate, int *Ldata, int *Rdata, int numsamples)
{
}

///-------------------------------------------------------
// reduced libbus system, only for Frequency Control
//-------------------------------------------------------

char			Manufacturer[128]={0};
char			Product[128]={0};
char			SerialNumber[128]={0};
int				Vmajor=0,Vminor=0;
usb_dev_handle	*usbH=NULL;

void WINAPI	CloseFiFiBus()
{
	if (usbH != NULL)
		{
		usb_release_interface(usbH, 0);
		usb_close(usbH);
		}
	usbH = NULL;
}

int WINAPI GetString(int id,char *str)
{
	char    buf[256];
	int     wlen, i;

	str[0]=0;
    if((wlen = usb_control_msg(usbH, USB_ENDPOINT_IN, USB_REQ_GET_DESCRIPTOR, (USB_DT_STRING << 8) + id, 0x409, buf, 256, 1000)) < 0)
		return wlen;

    if(buf[1] != USB_DT_STRING) return 0;
    if((int)buf[0] < wlen)  wlen = (int)buf[0];
    wlen/=2;

    /* wchar to char */
	for(i=1;i<wlen;i++)
		{
		if(i > 127) break;
		str[i-1] = buf[2 * i];
		if(buf[2 * i + 1] != 0) str[i-1] = '?';
		}

    str[i-1] = 0;
 	return i-1;
}


//FiFi-Firmware Commando ? or Softrock
//0x00 = GET_VERSION
//-----------------------------

BOOL WINAPI GetVersionsInfo ()
{
	if (!usbH) return FALSE;

	unsigned short sversion = 0;
	unsigned char  bversion = 0;

	// if any version of the ? pe0fko ? firmware
	if (usb_control_msg(usbH,USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN,0x00,0xA55A,0,(char*)&sversion,2, 500)==2)
		{
		Vmajor = (sversion >> 8) & 0xFF;
		Vminor = sversion & 0xFF;
		return TRUE;
		}

	// Get version of the new V2.0 SDR-Kit firmware
	if (usb_control_msg(usbH,USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN,0xFF,0,0,(char*)&bversion,1, 500)==1 && bversion != 0xFF)
		{
		Vmajor = (bversion >> 4) & 0x0F;
		Vminor = bversion & 0x0F;
		return TRUE;
		}

	return FALSE;
}

BOOL WINAPI OpenFiFiBus()
{
	struct usb_bus *ubus;
	struct usb_device *udev;

	usb_find_busses();		// find all busses
	usb_find_devices();		// find all connected devices

	for(ubus = usb_get_busses(); ubus; ubus = ubus->next) 
		{
		for(udev = ubus->devices; udev; udev = udev->next) 
			{
			if(udev->descriptor.idVendor == 0x16C0 && udev->descriptor.idProduct == 0x05DC)
				{
				if ((usbH = usb_open(udev)) != NULL)
					{
					if(GetString(udev->descriptor.iManufacturer,Manufacturer)
					&& GetString(udev->descriptor.iProduct,Product)
					&& GetString(udev->descriptor.iSerialNumber,SerialNumber)
					&& (usb_set_configuration(usbH, 1)>=0)
					&& (usb_claim_interface(usbH, 0)>=0))
						{
						GetVersionsInfo();
						return TRUE;
						}
					}
				CloseFiFiBus();
				}
			}
		}

	return FALSE;
}

//FiFi-Firmware Commando
//0x32 = SET_FREQ
//-----------------------------
//Set the frequency by value. 
//incl automatic band pass filter selection
//--------------------------------------------------------
//warum geteilt durch 250000 statt 1000000 ?
//Ja, klar, durch 4 geteilt, aber ich wei es nicht warum.
//--------------------------------------------------------
//why divided by 250000 instead 1000000 ? 
//yes, of course, divided by 4, but I do not know why.
//---------------------------------------------------------

int WINAPI SetFiFiFreq(int freq)
{
	if (!usbH) return 0;

	if(!myPara.msgHWND) //otherwise, by your own App, you set the frq.corretion 
		{
		//this here is for winrad or clones
		if(myPara.FreqCorrecture) freq+=(int)myPara.FreqCorrecture;
	    if(myPara.ScaleCorrecture) freq+=(int)((double)myPara.ScaleCorrecture/30000000.*(double)freq);
		}
	UINT ret,frq;

	frq = (UINT)(((double)(1UL << 21)) * ((double)freq/250000) + 0.5);
	ret = usb_control_msg(usbH,USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_OUT,0x32,0x0700,0,(char*)(&frq), sizeof(UINT),500);
	return ret == sizeof(UINT);
}

//------------------------------------------
// expansions of dll routines and funktions
//------------------------------------------

// if myPara.msgHWND != NULL, then this ExtIO.dll is controlled by an application other than Winrad or clone.
// Then, the communication with the Mircrosoft Message System is implemented - not the Mircrosoft untypical callback manner
//

void WINAPI InitExtIOPara(void* userPara)
{
	memcpy(&myPara,userPara,sizeof(EXTIQ_PARA));
}

HWND WINAPI GetExPara(EXTIQ_PARA *para)
{
	FIFI_INFO *info=(FIFI_INFO *)&myPara.InfoField;
	strcpy(info->Manufacturer,Manufacturer);
	strcpy(info->Product,Product);
	strcpy(info->SerialNumber,SerialNumber);
	info->MajorVersion=Vmajor;
	info->MinorVersion=Vminor;
	memcpy(para,&myPara,sizeof(EXTIQ_PARA));
	return myCtrl.m_hWnd;
}

void WINAPI SetExPara(EXTIQ_PARA *userPara)
{
	EXTIQ_PARA old;
	memcpy(&old,&myPara,sizeof(EXTIQ_PARA));
	memcpy(&myPara,userPara,sizeof(EXTIQ_PARA));

	if(old.FreqCorrecture!=userPara->FreqCorrecture
	|| old.ScaleCorrecture!=userPara->ScaleCorrecture
	|| old.dBOffset!=userPara->dBOffset) 
		{
		myCtrl.SetButtonState(); 
		}
}
