// GetColorDlg.cpp : implementation file

////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"
#include "GetColorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// GetColorDlg dialog


GetColorDlg::GetColorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(GetColorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(GetColorDlg)
	//}}AFX_DATA_INIT
	m_ColSelection=1;

}

void GetColorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(GetColorDlg)
	DDX_Control(pDX, IDC_COLOR_PICKER,	m_picker);
	DDX_Control(pDX, IDOK,				b_OK);
	DDX_Control(pDX, IDCANCEL,			b_CANCEL);
	DDX_Control(pDX, IDC_DEF_COL,		b_defcol);
	DDX_Control(pDX, IDC_ALT_COL,		b_altcol);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COL_OF_KNOB,	b_color[0]);
	DDX_Control(pDX, IDC_COL_OF_SCOPE,	b_color[1]);
	DDX_Control(pDX, IDC_COL_OF_SCOPE2,	b_color[2]);
	DDX_Control(pDX, IDC_DESIGN_1,		b_design[0]);
	DDX_Control(pDX, IDC_DESIGN_2,		b_design[1]);
	DDX_Control(pDX, IDC_DESIGN_3,		b_design[2]);
}

BEGIN_MESSAGE_MAP(GetColorDlg, CDialog)
	//{{AFX_MSG_MAP(GetColorDlg)
	ON_BN_CLICKED(IDC_COLOR_PICKER,		OnColorPicker)
	ON_BN_CLICKED(IDC_DEF_COL,			OnSetDEFcolor)
	ON_BN_CLICKED(IDC_ALT_COL,			OnSetALTcolor)
	ON_BN_CLICKED(IDC_COL_OF_SCOPE,		OnSelectScopeColor)
	ON_BN_CLICKED(IDC_COL_OF_SCOPE2,	OnSelectScopeColor2)
	ON_BN_CLICKED(IDC_COL_OF_KNOB,		OnSelectKnobColor)
	ON_BN_CLICKED(IDC_DESIGN_1,			OnColorDesing1)
	ON_BN_CLICKED(IDC_DESIGN_2,			OnColorDesing2)
	ON_BN_CLICKED(IDC_DESIGN_3,			OnColorDesing3)

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// GetColorDlg message handlers

BOOL GetColorDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	for(int i=0; i<3; i++)
		{
		old_KNOBFACE[i]=m_COL_KNOBFACE[i];
		old_SCOPE_B[i]=m_COL_SCOPE_B[i];
		old_SCOPE_B2[i]=m_COL_SCOPE_B2[i];
		}
	lastDesign=selectedDesign;

	m_picker.SetRGB(m_COL_SCOPE_B[selectedDesign],1);
	b_design[0].SetColor(desCol[0],1); 
	b_design[1].SetColor(desCol[1],1); 
	b_design[2].SetColor(desCol[2],1); 

	b_design[0].SetStyle(TAB_BOTTON);
	b_design[1].SetStyle(TAB_BOTTON);
	b_design[2].SetStyle(TAB_BOTTON);

	SelectColorSet(1);
	SelectColorDesing(selectedDesign);
	return TRUE;  
}

void GetColorDlg::OnColorPicker() 
{
	COLORREF col=m_picker.SetMyHSL();

	m_picker.SetRGB(col,0);
	m_picker.Invalidate();
	
	switch(m_ColSelection)
		{
		case 0: m_COL_KNOBFACE[selectedDesign]=col; break;
		case 1:	m_COL_SCOPE_B[selectedDesign]=col; break;
		case 2: m_COL_SCOPE_B2[selectedDesign]=col; break;
		}

	InitGraficUtilitys(selectedDesign);
	myMainFrm->RedrawWindow();
	b_design[selectedDesign].SetColor(desCol[selectedDesign],1); 
}

void GetColorDlg::OnCancel() 
{
	//restore the color
	for(int i=0; i<3; i++)
		{
		m_COL_KNOBFACE[i]=old_KNOBFACE[i];
		m_COL_SCOPE_B[i]=old_SCOPE_B[i];
		m_COL_SCOPE_B2[i]=old_SCOPE_B2[i];
		}
	InitGraficUtilitys(lastDesign);
	myMainFrm->RedrawWindow();
	CDialog::OnCancel();
}

void GetColorDlg::OnColorDesing1() {SelectColorDesing(0);}
void GetColorDlg::OnColorDesing2() {SelectColorDesing(1);}
void GetColorDlg::OnColorDesing3() {SelectColorDesing(2);}
void GetColorDlg::SelectColorDesing(int sel)
{
	for(int i=0; i<3; i++)
		{
		if(i==sel) b_design[i].SetCheck(1);
		else  b_design[i].SetCheck(0);
		}
	if(sel!=selectedDesign)	
		{
		InitGraficUtilitys(sel);
		myMainFrm->RedrawWindow();
		}
	SelectPickerColor();
}

void GetColorDlg::OnSelectScopeColor2() {SelectColorSet(2);}
void GetColorDlg::OnSelectScopeColor() {SelectColorSet(1);}
void GetColorDlg::OnSelectKnobColor() {SelectColorSet(0);}
void GetColorDlg::SelectColorSet(int sel)
{
	m_ColSelection=sel;

	for(int i=0; i<3; i++)
		{
		if(i==sel) b_color[i].SetCheck(1);
		else b_color[i].SetCheck(0);
		}

	SelectPickerColor();
}

void GetColorDlg::SelectPickerColor() 
{
	switch(m_ColSelection)
		{
		case 0:	m_picker.SetRGB(m_COL_KNOBFACE[selectedDesign],1); break;
		case 1:	m_picker.SetRGB(m_COL_SCOPE_B[selectedDesign],1); break;
		case 2:	m_picker.SetRGB(m_COL_SCOPE_B2[selectedDesign],1); break;
		}
	
	m_picker.Invalidate();
}

void GetColorDlg::SetDefinedColor(int altdef) 
{
	COLORREF  col_KNOBFACE[6]={0x00b0b1b2,0x0089a38d,0x009a91a0, 0x00d7be8e,0x00aabcaa,0x008e9ba5};
	COLORREF  col_SCOPE_B[6] ={0x009a7f4f,0x003e553e,0x008d8348, 0x00b49a68,0x00939c80,0x00617475};
	COLORREF  col_SCOPE_B2[6]={0x00675535,0x001d281d,0x005a532e, 0x008a7244,0x006c745a,0x003e4a4b}; 
	
	//for(int i=0; i<6; i++) col_SCOPE_B2[i]=AddBasisColor(col_SCOPE_B[i],-.15);

	m_COL_KNOBFACE[selectedDesign]=col_KNOBFACE[selectedDesign+altdef];
	m_COL_SCOPE_B[selectedDesign]=col_SCOPE_B[selectedDesign+altdef];
		
	InitGraficUtilitys(selectedDesign);
	myMainFrm->RedrawWindow();
	SelectPickerColor();
	b_design[selectedDesign].SetColor(desCol[selectedDesign],1); 
}

void GetColorDlg::OnSetDEFcolor() 
{
	SetDefinedColor(0);
}

void GetColorDlg::OnSetALTcolor() 
{
	SetDefinedColor(3);
}