// FaxViewMyColorButton.cpp : implementation file
//

#include "stdafx.h"
#include "MyColorButton.h"
#include "MyColorPalette.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyColorButton

MyColorButton::MyColorButton()
{
	m_dlg=NULL;
}

MyColorButton::~MyColorButton()
{
}


BEGIN_MESSAGE_MAP(MyColorButton, CButton)
	//{{AFX_MSG_MAP(MyColorButton)
	ON_WM_LBUTTONUP()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyColorButton message handlers

#define GRIDWIDTH 21
#define GRIDHIGHT 11
void MyColorButton::DrawColBottom(LPDRAWITEMSTRUCT lpD) 
{
	Draw(CDC::FromHandle(lpD->hDC));
}

void MyColorButton::ReDraw() 
{
	CClientDC dc(this);
	Draw(&dc);
}

void MyColorButton::Draw(CDC * pDrawDC) 
{

	CRect		rec,rt;
	int			x,y,z=0;
	char		txt[256];
	CString		str;

	if(!m_dlg) return;

	CBitmap		bitmap;
	CBitmap*	pOldBitmap=NULL;
	CDC			dc;
	CDC			*pDC = pDrawDC;


	if (dc.CreateCompatibleDC(pDrawDC))
		{
		if (bitmap.CreateCompatibleBitmap(pDrawDC,myRect.Width(),myRect.Height()))
			{
			pDC = &dc;
			pOldBitmap = dc.SelectObject(&bitmap);
			}
		}

	CFont* pOldFont=pDC->SelectObject (&myFond);
	
	pDC->FillRect(myRect,&bkbr);
	COLORREF cltTextOld=pDC->SetTextColor(COL_BTXT);
	pDC->SetBkMode(TRANSPARENT);


	rt.left=0; rt.right=GRIDWIDTH/2;
	rt.top=GRIDHIGHT;
	for(y=0; y<8; y++)
		{
		rt.bottom=rt.top+GRIDHIGHT;
		sprintf(txt,"%d",y+1); 
		pDC->DrawText(txt,&rt,DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		rt.top+=GRIDHIGHT;
		}

	rt.top=0; rt.bottom=rt.top+GRIDHIGHT;
	rt.left=rt.right; 

	for (x=0; x<32; x++)
		{
		rt.right=rt.left+GRIDWIDTH;
		sprintf(txt,"%d",x+1); 
		pDC->DrawText(txt,&rt,DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		rt.left+=GRIDWIDTH; 
		}

	rt.top=GRIDHIGHT;
	for(y=0; y<8; y++)
		{
		rt.left=GRIDWIDTH/2; 
		rt.bottom=rt.top+GRIDHIGHT;
		for (x=0; x<32; x++)
			{
			rt.right=rt.left+GRIDWIDTH;
			rec=rt;
			pDC->Draw3dRect (rec,myVLIGHT,myVDARK);
			rec.DeflateRect(1,1);
			pDC->FillSolidRect(&rec,m_dlg->workColors[y*32+x]); 
			rt.left+=GRIDWIDTH; 
			}
		rt.top+=GRIDHIGHT;
		}


	if(m_dlg->m_index>=0)
		{
		int index=m_dlg->m_index;
		rec.left=GRIDWIDTH/2+(index%32)*GRIDWIDTH;
		rec.top=GRIDHIGHT+(index/32)*GRIDHIGHT;
		rec.right=rec.left+GRIDWIDTH;
		rec.bottom=rec.top+GRIDHIGHT;
		pDC->Draw3dRect (rec,myVDARK,myVLIGHT);	
		rec.DeflateRect(1,1);
		pDC->Draw3dRect (rec,myDARKBACK,myLIGHT); 
		pDC->FillSolidRect(&rec,m_dlg->workColors[index]);
		}

	pDC->SelectObject (pOldFont);
	pDC->SetTextColor(cltTextOld);

	if (pDrawDC != pDC)
		{
		pDrawDC->BitBlt(myRect.left,myRect.top,myRect.Width(),myRect.Height(),&dc, 0, 0, SRCCOPY);
		dc.SelectObject(pOldBitmap);
		}
}


void MyColorButton::OnLButtonUp(UINT nFlags, CPoint point) 
{
	point.y-=GRIDWIDTH/2;
	point.x-=GRIDHIGHT;
	if(point.y>=0 && point.x>=0)
		{
		int set=((point.y/GRIDHIGHT)*32) + (point.x/GRIDWIDTH);
		m_dlg->SetIndex(set);
		}
	CButton::OnLButtonUp(nFlags, point);
}

void MyColorButton::Init(class MyColorPalette *dlg) 
{
	m_dlg=dlg;

	LOGFONT	lf=			{
					   -8,	//lfHeight;
						0,	//lfWidth;
						0,	//lfEscapement;
						0,	//lfOrientation;
				FW_NORMAL,	//lfWeight;
						0,	//lfItalic;
						0,	//lfUnderline;
						0,	//lfStrikeOut;
						0,	//lfCharSet;
						0,	//lfOutPrecision;
						0,	//lfClipPrecision;
						0,	//lfQuality;
VARIABLE_PITCH | FF_SWISS,	//lfPitchAndFamily;
			{"Small Fonts\0"}};	//lfFaceN

	myFond.CreateFontIndirect(&lf);
	GetClientRect(myRect);
}

BOOL MyColorButton::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE	;
}
