// olorPickerButton.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "../GlobalTools.h"
#include "MyColorPickerButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "MyColorButton.h"


/////////////////////////////////////////////////////////////////////////////
// MyColorPickerButton
IMPLEMENT_DYNCREATE(MyColorPickerButton, CButton)
MyColorPickerButton::MyColorPickerButton()
{
	mouse_activ=init=m_Y=0;
}

MyColorPickerButton::~MyColorPickerButton()
{
}


BEGIN_MESSAGE_MAP(MyColorPickerButton, CButton)
	//{{AFX_MSG_MAP(MyColorPickerButton)
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_SETCURSOR()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyColorPickerButton message handlers

void MyColorPickerButton::DrawItem(LPDRAWITEMSTRUCT di) 
{
	CRect		re=di->rcItem;
	CRect		rx=di->rcItem;
	CBrush		bkbr(COL_BACK);
	re.right-=36;
	rx.left=re.right+7;
	rx.right=di->rcItem.right-1;

	CRect		rl=rx;
	CRect		rr=rx;
	rl.right=rl.left+16;
	rr.left=rl.right;
	rr.right=rr.left+16;

	init=1;

	CDC* pDC=CDC::FromHandle(di->hDC);

	CSize szColorPicker = re.Size ();
	myRect=re;
	myRect.DeflateRect(1,1);

	if (m_bmpPicker.GetSafeHandle () == NULL)
	{
		// Prepare picker's bitmap:
		CDC dcMem;
		if (dcMem.CreateCompatibleDC (pDC) &&
			m_bmpPicker.CreateCompatibleBitmap (pDC, szColorPicker.cx, szColorPicker.cy))
		{
			CBitmap* pOldBmp = dcMem.SelectObject (&m_bmpPicker);
			dcMem.FillRect(myRect,&bkbr);

			int nStep = (dcMem.GetDeviceCaps (BITSPIXEL) > 8) ? 1 : 4;
			int cy=szColorPicker.cy-2;
			int cx=szColorPicker.cx-2;

			dcMem.Draw3dRect (re,myVDARK,myVLIGHT);

			for (int i= 0;i<cy;i += nStep)
			{
				for(int j=0;j<cx;j += nStep)
				{
					CPoint pt (j+1, cy - i - nStep+1);
					COLORREF color = HLStoRGB_ONE((double)j/(double)szColorPicker.cx, 0.5f, (double)i/(double)szColorPicker.cy);

					if (dcMem.GetDeviceCaps (BITSPIXEL) > 8) // High/True color
					{
						// Draw exact color:
						dcMem.SetPixelV (pt, color);
					}
					else
					{
						// Draw dithered rectangle:
						CBrush br (color);
						dcMem.FillRect (CRect (pt, CSize (nStep, nStep)), &br);
					}
				}
			}


			dcMem.SelectObject (pOldBmp);
		}
	}


	pDC->DrawState (CPoint (0, 0), szColorPicker, &m_bmpPicker, DSS_NORMAL);

	re=myRect;
	re.left=rr.right;

	pDC->FillRect(re,&bkbr);

	DrawLuminace(pDC,rl,rr);

	if(m_Y!=-100)
		{
		//draw cursor
		CPen pen;
		pen.CreatePen(PS_SOLID, 1,RGB(255,255,255));
		CPen *OldPen =pDC->SelectObject(&pen);
	
		// Top
		pDC->MoveTo(colorP.x,colorP.y-5);
		pDC->LineTo(colorP.x,colorP.y-1);
	
		// Bottom
		pDC->MoveTo(colorP.x,colorP.y+5);
		pDC->LineTo(colorP.x,colorP.y+1);

		// Left
		pDC->MoveTo(colorP.x-5,colorP.y);
		pDC->LineTo(colorP.x-1,colorP.y);

		// Right
		pDC->MoveTo(colorP.x+5,colorP.y);
		pDC->LineTo(colorP.x+1,colorP.y);
	
		pDC->SelectObject(OldPen);
	}

}

void MyColorPickerButton::DrawLuminace(CDC* pDC, CRect &rl, CRect &rr) 
{
	COLORREF	col;
	rl.left+=5;
	rl.right+=5;
	int			y,h;

	pDC->Draw3dRect (rl,myVDARK,myVLIGHT);
	if(m_Y==-100) return;
		

	rl.DeflateRect(1,1);
	l_Rect=rl;

	h=rl.Height();


	for (y = rl.top; y < rl.bottom; y ++)
		{
		col = 	HLStoRGB_ONE (m_dblHue, 1. - (double)y/(double)h, m_dblSat);
		CBrush br (col);
		pDC->FillRect(CRect (rl.left, y,rl.right,y+1), &br);
		}

	

	rr.left+=5;

	POINT pt[3];
	pt[0].x = rr.right-5;
	pt[0].y = m_Y-4;
	
	pt[1].x = rr.left;
	pt[1].y = m_Y;
	
	pt[2].x = rr.right-5;
	pt[2].y = m_Y+4;
	
	COLORREF ref=COL_BTXT;

	CPen pen (PS_SOLID, 1,ref);
	CBrush	pBrush(ref);

	CBrush* poldBrush = pDC->SelectObject (&pBrush);
	CPen* poldPen = pDC->SelectObject(&pen);

	pDC->Polygon(pt, 3);

	pDC->SelectObject(poldBrush);
	pDC->SelectObject(poldPen);
}


void MyColorPickerButton::SetRGB (COLORREF ref,int flag)
{
	// compute conversion to HSL
	// place the rectangle on the nearest color
	RGBtoHSL (ref, &m_dblHue, &m_dblSat, &m_dblLum);

	if(!init) 
		{
		GetClientRect(myRect); myRect.right-=36;
		myRect.DeflateRect(1,1);
		}
	CRect re=myRect;
	colorP.x=(int)((double) re.Width () * m_dblHue)+1;
	colorP.y=(int)((1. - m_dblSat) * (double)re.Height ())+1;

	l_dblHue=m_dblHue;
	l_dblSat=m_dblSat;
	if(flag) l_dblLum=m_dblLum;
	m_Y=l_Y= (int)((1.-l_dblLum)*(double)re.Height())+1;

	m_colorNew=ref;
	RedrawWindow();
}

COLORREF MyColorPickerButton::SetMyHSL()
{
	m_dblHue=l_dblHue;
	m_dblSat=l_dblSat;
	m_dblLum=l_dblLum;

	CRect re=myRect;
	colorP.x=(int)((double) re.Width () * m_dblHue)+1;
	colorP.y=(int)((1. - m_dblSat) * (double)re.Height ())+1;
	m_Y=l_Y= (int)((1.-m_dblLum)*(double)re.Height())+1;
	return m_colorNew;
}

void MyColorPickerButton::SetRGBLUM (int flag, COLORREF ref, double lumi)
{
	RGBtoHSL (ref, &m_dblHue, &m_dblSat, &m_dblLum);
	if(lumi) m_dblLum=lumi;
	CRect re=myRect;

	colorP.x=(int)((double) re.Width () * m_dblHue)+1;
	colorP.y=(int)((1. - m_dblSat) * (double)re.Height ())+1;

	l_dblHue=m_dblHue;
	l_dblSat=m_dblSat;
	l_dblLum=m_dblLum;
	m_Y=l_Y= (int)((1.-l_dblLum)*(double)re.Height())+1;
	m_colorNew=ref;
	Invalidate();
}

void MyColorPickerButton::SetPoint(CPoint point) 
{
	CRect re=myRect;
	if (re.PtInRect (point))
		{
		point.y--;
		if(point.y>=re.Height()) point.y=re.Height()-1;
		point.x--;
		if(point.x>=re.Width()) point.x=re.Width()-1;

		l_dblHue = (double) point.x / (double) re.Width ();
		l_dblSat = 1. - (double) point.y / (double)re.Height ();
		//l_dblLum =m_dblLum;
		//m_Y=l_Y= (int)((1.-l_dblLum)*(double)re.Height())+1;
		m_colorNew = HLStoRGB_ONE(l_dblHue,l_dblLum,l_dblSat);
		if(mouse_activ)
			{
			GetParent ()->SendMessage (	WM_COMMAND,
								MAKEWPARAM (GetDlgCtrlID (), BN_CLICKED),
								(LPARAM) m_hWnd);
			}
		}
	else
		{
		re=l_Rect;
		if (re.PtInRect (point))
			{
			point.y--;
			if(point.y>=re.Height()) point.y=re.Height()-1;
			l_Y=point.y;
			l_dblHue = m_dblHue;
			l_dblSat = m_dblSat;
			l_dblLum = 1. - (double)point.y/(double)re.Height();
			//m_Y=l_Y= (int)((1.-l_dblLum)*(double)re.Height())+1;
			m_colorNew = HLStoRGB_ONE(l_dblHue,l_dblLum,l_dblSat);
			if(mouse_activ)
				{
				GetParent ()->SendMessage (	WM_COMMAND,
									MAKEWPARAM (GetDlgCtrlID (), BN_CLICKED),
									(LPARAM) m_hWnd);
				}
			}
		}
	Invalidate();

}

void MyColorPickerButton::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(m_Y==-100) return;
	if (mouse_activ)
		{
		ReleaseCapture ();
		::SetCursor (m_Hand);
		}
	mouse_activ = FALSE;
	SetPoint(point);
	CButton::OnLButtonUp(nFlags, point);
}

void MyColorPickerButton::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(mouse_activ)	SetPoint(point);
	CButton::OnMouseMove(nFlags, point);
}

void MyColorPickerButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if(m_Y==-100) return;
	if(!mouse_activ)
		{
		SetCapture (); 
		::SetCursor (m_FingerDown);
		}

	mouse_activ=1;
	SetPoint(point);

	CButton::OnLButtonDown(nFlags, point);
}


BOOL MyColorPickerButton::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	//if(GetCursor()!=m_Hand)
	{
		CRect rectClient;
		GetClientRect (rectClient);

		CPoint ptCursor;
		::GetCursorPos (&ptCursor);
		ScreenToClient (&ptCursor);

		if (rectClient.PtInRect (ptCursor))
		{
			::SetCursor (m_Hand);
			return TRUE;
		}
	}
	
	
	return CButton::OnSetCursor(pWnd, nHitTest, message);
}


BOOL MyColorPickerButton::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE	;
}