// MyFFT.h: FFT in Decibel.

//////////////////////////////////////////////////////////////////////

#if !defined(notMY_FFT)
#define notMY_FFT

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define MAX_FFT_SIZE 0x80000
#define MIN_FFT_SIZE 0x400
#define MAX_PLOT_SIZE 4096

class MyFFT  
{
public:
	void SetFFTParams( BOOL Complex, int size, int ave,
						BOOL invert, double dBCompensation, 
						double IQoffset, int SampleFreq);
	void ResetFFT();
	BOOL GetDoubleFFTData(int start, int stop, double* OutBuf );
	BOOL GetScreenIntegerFFTData(float *InBuf, int MaxHeight, int MaxWidth,
									double MaxdB, double MindB,
									int StartFreq, int StopFreq,
									POINT *pt);
	int PutInFFT(short* InBuf);
	void PutInFFT(float* InBuf, int size);
	void PutInFFT(short* InBuf, int size);
	MyFFT();
	virtual ~MyFFT();

	void FreeMemory();
	void makewt(int nw, int *ip, double *w);
	void makect(int nc, int *ip, double *c);
	void bitrv2(int n, int *ip, double *a);
	void cftfsub(int n, double *a, double *w);
	void rftfsub(int n, double *a, int nc, double *c);
	void CpxFFT(int n, double *a, double *w);
	void cft1st(int n, double *a, double *w);
	void cftmdl(int n, int l, double *a, double *w);

	BOOL m_Complex;
	BOOL m_LastComplex;

	BOOL m_Overload;
	BOOL m_Invert;
	int m_AveCount;
	int m_TotalCount;
	int m_LastAve;
	int m_FFTSize;
	int m_FFTinCntr;
	int m_LastFFTSize;
	int m_AveSize;
	int m_StartFreq;
	int m_StopFreq;
	int m_BinMin;
	int m_BinMax;
	int m_PlotWidth;

	int			m_spow;
	float		*RealWin,*RealData,*MagData,*ImgData;

	double m_K_C;
	double m_K_B;
	double m_dBCompensation;
	double m_SampleFreq;
	double m_IQoffset;
	int* pWorkArea;
	int* m_pTranslateTbl;
	double* pSinCosTbl;
	double* pWindowTbl;
	double* pFFTAveBuf;
	double* pFFTSumBuf;
	double* pFFTInBuf;
};

#endif // !defined(notMY_FFT)
