////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "../GlobalTools.h"
#include "MyPeekMeter.h"

#ifdef _SET_DEBUG_NEW
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// yes I now - peakmeter, but I have two, therfor peekmeter
IMPLEMENT_DYNCREATE(MyPeekMeter, CButton)

BEGIN_MESSAGE_MAP(MyPeekMeter, CButton)
	//{{AFX_MSG_MAP(MyPeekMeter)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


MyPeekMeter::MyPeekMeter()
{
	m_delayA=.1f; m_delayB=.9f;
	oldVal=0;		
	m_sval=0;
	m_PeekMax=32768.f;			//max amplitude 
}

MyPeekMeter::~MyPeekMeter(){}
void MyPeekMeter::DrawItem(LPDRAWITEMSTRUCT lpDIS) {};

BOOL MyPeekMeter::Init(DWORD flags, LPCTSTR txt)
{
	m_flags = flags; m_text = txt;
	m_delayA=.1f; m_delayB=.9f;
	
	oldVal=0;		
	m_sval=0;
	m_PeekMax=32768.f;			//max amplitude 
	GetClientRect(&m_size);
	return TRUE;
}

BOOL MyPeekMeter::OnEraseBkgnd(CDC* /*pDC*/) 
{
	return TRUE;
}
//delay = 1 to 100 100% and 25% steps
void MyPeekMeter::SetRange(int PeekMax)
{
	m_PeekMax = (float)PeekMax; 
}

void MyPeekMeter::SetDelay(int delay)
{
	if(delay<1) delay=1;
	if(delay>100) delay=100;
	m_delayB = (float)delay/100;
	m_delayA = 1.f-m_delayB;
}

void MyPeekMeter::Set(int v) 
{
	if(v>100) v=100;
	if(v<0) v=0;
	m_sval= v/100.f; 
	oldVal=(int)m_sval;
	RedrawWindow();
}

void MyPeekMeter::SetPeakMeterInDB(float v)  
{
	float a1=m_PeekMax/140.f;   //140 dB maximum
	if(v>140.f) v=m_PeekMax;
	else v=a1*v;
	SetPeakMeter((int)v);
}

void MyPeekMeter::SetPeakMeter(int val)  
{
	float newval=m_sval*m_delayA+((float)val/m_PeekMax)*m_delayB;
	if(newval>1.f) newval=1.f;
	val=(int)(newval*100.f);
	if(val!=oldVal)
		{
		m_sval=newval;
		oldVal=val;
		RedrawWindow();
		} 
}

void MyPeekMeter::OnPaint() 
{
	if(m_hWnd && IsWindowVisible())
		{
		CPaintDC dc(this); // device context for painting
		Draw(&dc);
		}
}

void MyPeekMeter::Draw(CDC *pDC)
{
	CBrush		bBrush(COL_BACK);
	CDC			dc;
	HPEN		hp;
	CBitmap		bitmap;
	CBitmap*	pOldBitmap;
	HDC			hdc=0;
	HBITMAP		hbm=0;
	HBRUSH		hb;
	RECT		re,bre,scl;
	HFONT		hf;
	SIZE		si;
	int			i,j,v,x,y,xs,ys,r,b,g,w,m_sstep;
	char		txt[16];
	WORD		bpattern[] = {0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0,0};

	try
		{
		xs = m_size.Width(); ys = m_size.Height();
		if (dc.CreateCompatibleDC(pDC))
			{
			if (bitmap.CreateCompatibleBitmap(pDC,xs, ys))
				{
				pOldBitmap = dc.SelectObject(&bitmap);
				}
			}

		hdc=dc.m_hDC;

		::SetRect(&re,0,0,xs,ys);
		if(!(hbm = ::CreateBitmap(8,8,1,1,bpattern))) throw 0;
		hb = ::CreateSolidBrush(COL_BACK); ::FillRect(hdc,&re,hb); ::DeleteObject(hb);	// Hintergrund
		//dc.Draw3dRect(&re,myVDARK,myLIGHT);

		hf = (HFONT)::SelectObject(hdc,::CreateFont(-9,0,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH|FF_SWISS,"Small Fonts"));
		::SetTextAlign(hdc,TA_TOP); 
		::SetBkMode(hdc,TRANSPARENT);
		::SetTextColor(hdc,COL_BTXT);

		re.bottom=12; re.right-=10;
		//::TextOut(hdc,18,1,m_text,strlen(m_text));
		dc.DrawText(m_text, &re, DT_SINGLELINE|DT_VCENTER|DT_CENTER);
		re.top=12; re.bottom=ys; re.right=xs;
		ys-=12; 
		bre = re;

		bre.bottom = bre.bottom * 46 / 100;

		::OffsetRect(&bre,__max((xs-16)/100,4),__max(ys/20,4));
		sprintf(txt,"%d",0);
		::GetTextExtentPoint32(hdc,txt,strlen(txt),&si);
	//	bre.left += si.cx >> 1;
		sprintf(txt,"%d",100);
		::GetTextExtentPoint32(hdc,txt,strlen(txt),&si);
		bre.right -= (si.cx >> 1)+8;

		if((bre.right-bre.left)>40) m_sstep=25;
		else m_sstep=50;


		y = re.bottom - ((re.bottom - bre.bottom) >> 1);
		x = 100 / m_sstep + 1;
		hp = (HPEN)::SelectObject(hdc,CreatePen(PS_SOLID,1,COL_BTXT));
		for(i=0; i<x; i++)
			{
			v = i * m_sstep;
			sprintf(txt,"%d",v);
			::GetTextExtentPoint32(hdc,txt,strlen(txt),&si);
			::TextOut(hdc,bre.left+i*(bre.right-bre.left)/(x-1)	-(si.cx>>1),y-(si.cy>>1),txt,strlen(txt));
			v = bre.left+i*(bre.right-bre.left)/(x-1);
			::MoveToEx(hdc,v,bre.bottom+ys*2/100,0);
			::LineTo(hdc,v,bre.bottom+ys*5/100);
			}
		::DeleteObject(SelectObject(hdc,hp));
		::DeleteObject(SelectObject(hdc,hf));

		::FillRect(hdc,&bre,bBrush);
		dc.Draw3dRect(&bre,myVDARK,myLIGHT);

		if(m_sval)
			{
			y = (int)((float)(bre.right-bre.left) * m_sval);

			::InflateRect(&bre,-2,-2); 	re = bre;
		
			scl.bottom=bre.bottom;
			scl.top=bre.top;
			scl.right = bre.left + y;
			w=bre.right-bre.left;
			j=w*10/15; w-=j;
			for(x=-j,i=bre.left; i<=(bre.left + y); i+=3,x+=3)
				{
				if(i>bre.right) break;
				scl.left=i;
				scl.right=i+2;
				if(x>0)
					{
					r= min(255,((GetRValue(myVDARK) * (w-x) + GetRValue(COL_SCOPEMARK) * x) / w));
					g= min(255,((GetGValue(myVDARK) * (w-x) + GetGValue(COL_SCOPEMARK) * x) / w));
					b= min(255,((GetBValue(myVDARK) * (w-x) + GetBValue(COL_SCOPEMARK) * x) / w));
					::FillRect(hdc,&scl,CBrush(RGB(r,g,b)));
					}
				else ::FillRect(hdc,&scl,CBrush(myVDARK));
				}
			}
	
		pDC->BitBlt(m_size.left,m_size.top,m_size.Width(),m_size.Height(),&dc, 0, 0, SRCCOPY);
		dc.SelectObject(pOldBitmap);
		}
	catch(int err) {err;}
	if(hbm) ::DeleteObject(hbm);
	ValidateRect(&m_size);
}