////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "../GlobalTools.h"
#include "MyPoti.h"

#ifdef _SET_DEBUG_NEW
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyPoti
IMPLEMENT_DYNCREATE(MyPoti, CButton)

BEGIN_MESSAGE_MAP(MyPoti, CButton)
	//{{AFX_MSG_MAP(MyPoti)
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()
	ON_WM_MOUSEWHEEL()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONDBLCLK()
	ON_WM_RBUTTONUP()
	ON_WM_TIMER()
	ON_WM_MOUSEMOVE()
	ON_WM_ENABLE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

MyPoti::MyPoti()
{
	setValues=0;
	m_time = 200;
	m_tid =init=0;
	
	memset(&myInfo,0,sizeof(POTI_DRAWINFO));
	myInfo.m_srange = 270; 
	m_step = m_largestep = 13;
	myInfo.m_ledcol = RGB(240,40,0);
	prell=0;
	centerPoint=lastDoubleClick=0;
	MyReflector=NULL;
	myFaceColor=0;
}

MyPoti::~MyPoti(){}

void MyPoti::Set(int v, int reflect)
{
	if(v<0) v=0;
	if(v>myInfo.m_srange) v=myInfo.m_srange;
	myInfo.m_sval=v;

	int xRange=myInfo.m_srange/4+1;
	int uRange=(myInfo.m_srange/4*3);
	int z=xRange/40;


	myInfo.m_mark=0;
	switch(myInfo.m_markpoint)
		{
		default:
		case	MARK_CLEAR:	break;
		case	MARK_TOP:	if(v>=(myInfo.m_srange*19/40) && v<=(myInfo.m_srange*21/40)) myInfo.m_mark=1;
							break;
		case	MARK_RIGHT:	if(v>=(myInfo.m_srange*39/40) && v<=myInfo.m_srange) myInfo.m_mark=1;
							break;
		case	MARK_LEFT:	if(v>=0 && v<=(myInfo.m_srange/40)) myInfo.m_mark=1;
							break;
		case	MARK_L14:	if(v>=(xRange-z) && v<=(xRange+z)) myInfo.m_mark=2;	//mark left 1/4 range
							break;
		case	MARK_L34:	if(v>=(uRange-z) && v<=(uRange+z)) myInfo.m_mark=2;	//mark left 3/4 range
							break;
		case	SET_TOP:	if(v==(myInfo.m_srange/2)) myInfo.m_mark=2;
							break;
		case	SET_RIGHT:	if(v==myInfo.m_srange) myInfo.m_mark=2;
							break;
		case	SET_LEFT:	if(!v) myInfo.m_mark=2;
							break;
		}

	switch(myInfo.m_markpoint)
		{
		default:
		case	SET_LEFT:
		case	MARK_LEFT:
		case	MARK_CLEAR:	centerPoint=0; break;
		case	MARK_TOP:	centerPoint=myInfo.m_srange*20/40; break;
		case	MARK_RIGHT:	centerPoint=myInfo.m_srange; break;
		case	MARK_L14:	centerPoint=xRange;	break;
		case	MARK_L34:	centerPoint=uRange;	break;
		case	SET_TOP:	centerPoint=myInfo.m_srange/2; break;
		case	SET_RIGHT:	centerPoint=myInfo.m_srange; break;
		}

	if(setValues) sprintf(myInfo.ExtraText,"%d",myInfo.m_sval);

	::InvalidateRect(m_hWnd,0,FALSE);
	if(MyReflector && !reflect) MyReflector->Set(v,1);

}

BOOL MyPoti::Init(char *txt,int range,int largestep,COLORREF ledCol, DWORD flags)
{
	myInfo.m_sval = 0;
	GetClientRect(&m_size);

	myFaceColor=0;
	strncpy(myInfo.Title,txt,63); myInfo.Title[63]=0;

	if((int)flags<=MARK_TOP)
		{
		myInfo.m_markpoint=flags;
		flags=0;
		}
	if(flags==2) flags=0;

	if(ledCol)
		{
		myInfo.m_flags = flags|RM_POTILED;
		myInfo.m_ledcol = ledCol;
		}
	else myInfo.m_flags = flags;
	
	myInfo.m_srange=range;
	m_largestep=largestep;

	::InvalidateRect(m_hWnd,0,FALSE);
	return NULL;
}


//****************************************************************************
void MyPoti::PreSubclassWindow() 
{
	ModifyStyle (BS_DEFPUSHBUTTON, BS_OWNERDRAW);
	CButton::PreSubclassWindow();
}


BOOL MyPoti::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= BS_OWNERDRAW;
	cs.style &= ~BS_DEFPUSHBUTTON;

	return CButton::PreCreateWindow(cs);
}

BOOL MyPoti::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	dwStyle |= BS_OWNERDRAW;
	dwStyle &= ~BS_DEFPUSHBUTTON;
	
	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

int MyPoti::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style |= BS_OWNERDRAW;
	lpCreateStruct->style &= ~BS_DEFPUSHBUTTON;

	if (CButton::OnCreate(lpCreateStruct) == -1) return -1;
	
	return 0;
}

BOOL MyPoti::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	ScreenToClient (&pt);
	int dev;

	if (nFlags & MK_RBUTTON)
		{
		dev=1; 
		}
	else dev=m_largestep;

	if(zDelta<0) myInfo.m_sval-=dev;
	else myInfo.m_sval+=dev;

	if(myInfo.m_sval>myInfo.m_srange) myInfo.m_sval=myInfo.m_srange; 
	if(myInfo.m_sval<0) myInfo.m_sval=0;
	GetParent()->SendMessage (WM_POTICHANGE, (WPARAM)m_hWnd,myInfo.m_sval);
	if(setValues) sprintf(myInfo.ExtraText,"%d",myInfo.m_sval);
	Invalidate();
	return TRUE;
	
	//return CButton::OnMouseWheel(nFlags, zDelta, pt);
}

void MyPoti::OnMouseMove(UINT nFlags, CPoint point) 
{
	CheckSetCursor();
	CButton::OnMouseMove(nFlags, point);
}

void MyPoti::CheckSetCursor() 
{
	if(GetDir()==-1) 
		{
		if(::GetCursor()!= m_UpHand) ::SetCursor(m_UpHand);
		}
	else
		{
		if(::GetCursor()!= m_DownHand) ::SetCursor(m_DownHand);
		}

}

BOOL MyPoti::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	CRect rectClient;
	GetClientRect (rectClient);

	CPoint ptCursor;
	::GetCursorPos (&ptCursor);
	ScreenToClient (&ptCursor);

	if (rectClient.PtInRect (ptCursor))
		{
		if(GetFocus()!=this) SetFocus();
		CheckSetCursor();
		return TRUE;
		}

	return CButton::OnSetCursor(pWnd, nHitTest, message);
}

#include <math.h>
int MyPoti::GetDir()
{
	CRect	re;
	CPoint	pt;

	GetClientRect(&re); 
	::GetCursorPos(&pt); 
	ScreenToClient(&pt);
	if(!re.PtInRect(pt)) return 0;
//	if(GetFocus()!=this)  SetFocus();
	if(pt.x < re.left + (re.Width() >> 1)) return -1;
	return 1;
}

void MyPoti::SetLed(BOOL onoff)
{
	if(onoff) myInfo.m_flags |= RM_ON; else myInfo.m_flags &= ~RM_ON;
	Invalidate();
}

void MyPoti::SetLedColor(COLORREF co)
{
	myInfo.m_ledcol = co;
	Invalidate();
}

void MyPoti::SetFaceColor(COLORREF co)
{
	myFaceColor=co;
	Invalidate();
}

//****************************************************************************
BOOL MyPoti::OnEraseBkgnd(CDC* /*pDC*/) 
{
	return TRUE;
}

void MyPoti::DrawItem(LPDRAWITEMSTRUCT lpDIS) 
{
	myInfo.lpDIS=lpDIS;
	if(myFaceColor) myInfo.m_facecol=myFaceColor;
	else myInfo.m_facecol=COL_KNOBFACE;
	DrawPotiLayout(&myInfo);
}

void MyPoti::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if(!m_tid) m_tid = SetTimer(1,m_time<<1,0);
	m_step = m_largestep; prell=1; PostMessage(WM_TIMER,m_tid,0);
	::SetCursor(m_FingerDown);
}

void MyPoti::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	Set(centerPoint);
	lastDoubleClick=1;
	::SendMessage(::GetParent(m_hWnd),WM_POTICHANGE,(WPARAM)m_hWnd,(LPARAM)centerPoint); 
	lastDoubleClick=0;
}

void MyPoti::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(m_tid) {KillTimer(m_tid); m_tid = 0;}
	::SetCursor(m_Hand);
}

void MyPoti::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if(!m_tid) m_tid = SetTimer(1,m_time<<1,0);
	m_step = 1; prell=1; PostMessage(WM_TIMER,m_tid,0);
	::SetCursor(m_FingerRight);
}

void MyPoti::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	if(!m_tid) m_tid = SetTimer(1,m_time<<1,0);
	m_step = 1; prell=1; PostMessage(WM_TIMER,m_tid,0);
}

void MyPoti::OnRButtonUp(UINT nFlags, CPoint point) 
{
	if(m_tid) {KillTimer(m_tid); m_tid = 0;}
	::SetCursor(m_Hand);
}

void MyPoti::OnTimer(UINT nIDEvent) 
{
	int	i;
	if(nIDEvent == m_tid)
		{
		KillTimer(m_tid);
		if((i = GetDir()))
			{
			if(prell) 
				{
				prell=0;
				m_tid = SetTimer(1,m_time*4,0);
				}
			else  m_tid = SetTimer(1,m_time,0);

			myInfo.m_sval += i * m_step; 
			if(myInfo.m_sval < 0) myInfo.m_sval = 0; if(myInfo.m_sval > myInfo.m_srange) myInfo.m_sval = myInfo.m_srange;
			if(setValues) sprintf(myInfo.ExtraText,"%d",myInfo.m_sval);
			::PostMessage(::GetParent(m_hWnd),WM_POTICHANGE,(WPARAM)m_hWnd,(LPARAM)myInfo.m_sval); Invalidate();
			}
	}
}

void MyPoti::OnEnable(BOOL bEnable) 
{
	CButton::OnEnable(bEnable);
	Invalidate();
}