// MyPoti.h: interface for the MyPoti class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYPOTI)
#define AFX_MYPOTI

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define MARK_CLEAR	0
#define MARK_LEFT	-1
#define MARK_RIGHT	-2
#define MARK_TOP	1
#define SET_LEFT	-3
#define SET_RIGHT	-4
#define SET_TOP		-5
#define MARK_L14	-6	//mark left 1/4 range
#define MARK_L34	-7	//mark left 3/4 range

#define RM_ON			(0x01)
#define RM_POTILED		(0x100)	


#include "../RJ10M-DLL.h"

class MyPoti : public CButton
{
	DECLARE_DYNCREATE(MyPoti)
public:		

	MyPoti();

	POTI_DRAWINFO myInfo;

	CRect		m_size;

	int			lastDoubleClick,m_step,m_largestep;
	int			m_dir,m_time,prell,centerPoint,setValues;
	UINT		m_tid;
	COLORREF	myFaceColor;

	MyPoti		*MyReflector;

	int			GetDir();
	void		CheckSetCursor();
	void		SetLed(BOOL onoff);
	void		SetLedColor(COLORREF co);
	void		SetFaceColor(COLORREF co);

	int			init;

	BOOL		Init(char *txt,int range=270,int largestep=15,COLORREF co=NULL,DWORD flags=2);
	void		MarkPoint(int mark){myInfo.m_markpoint=mark;}
	void		Set(int v,int reflect=0);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyPoti)
protected:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void PreSubclassWindow();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~MyPoti();
	// Generated message map functions
	//{{AFX_MSG(MyPoti)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnEnable(BOOL bEnable);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#endif // !defined(AFX_MYPOTI)
