////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "RJ10-GPIO.h"
#include <setupapi.h>

RJ10_GPIO::RJ10_GPIO()
{
	hhid=NULL; 
	PnPHandle=NULL; 
	HIDHandle=CheckHandle=NULL;	
}

RJ10_GPIO::~RJ10_GPIO()	
{
	HIDCleanup();
}

int RJ10_GPIO::LoadHidDll() 
{ 
	if(hhid) UnloadHidDll();
	hhid = LoadLibrary("hid.dll");	 
	if(hhid == NULL) return 0; 
	else 
		{ 
		//Get dll function entrys by function name 
		if(!(HID_GetHidGuid			=(void (WINAPI*)(LPGUID HIDGuid))GetProcAddress(hhid,"HidD_GetHidGuid"))) return 0; 
		if(!(HID_GetAttributes			=(BOOLEAN (WINAPI*)(HANDLE HidDeviceObject, PHID_ATTRIBUTES Attributes))GetProcAddress(hhid,"HidD_GetAttributes")))  return 0; 
		if(!(HID_GetManufacturerString	=(BOOLEAN (WINAPI*)(HANDLE HidDeviceObject,PVOID Buffer,ULONG BufferLength))GetProcAddress(hhid,"HidD_GetManufacturerString"))) return 0; 
		if(!(HID_GetProductString		=(BOOLEAN (WINAPI*)(HANDLE HidDeviceObject,PVOID Buffer,ULONG BufferLength))GetProcAddress(hhid,"HidD_GetProductString")))  return 0; 
		if(!(HID_GetIndexedString		=(BOOLEAN (WINAPI*)(HANDLE HidDeviceObject,ULONG Index,PVOID Buffer,ULONG BufferLength))GetProcAddress(hhid,"HidD_GetIndexedString"))) return 0; 
		} 
  return 1; 
} 
 
void RJ10_GPIO::UnloadHidDll() 
{ 
	if(hhid) 
		{  
		FreeLibrary(hhid);  
		hhid=NULL;  
		} 
} 

void RJ10_GPIO::CleanCheckHandle()
{ 
	if(CheckHandle && CheckHandle!=INVALID_HANDLE_VALUE) CloseHandle(CheckHandle); 
	CheckHandle=NULL;
}

int RJ10_GPIO::GetDeviceList() 
{ 
	HID_DEVICE	mDev={0};
	struct _GUID HIDGuid; 
	struct {DWORD size; char path[256];} HIDDeviceData; 
 
	SP_INTERFACE_DEVICE_DATA DeviceInterfaceData; 
	HID_ATTRIBUTES HIDDevice; 
 
	int Success, HidDevice, ret=0, i; 
	unsigned long BytesReturned; 
 
		
	char tmp[16];		
	UBYTE buffer[256];	//don't use more than 253 bytes ! 

	if(!hhid) 
		{
		if(!LoadHidDll()) { HIDCleanup(); return 0; } 
		}
 
	HID_GetHidGuid(&HIDGuid); 
 
	PnPHandle=SetupDiGetClassDevs(&HIDGuid,0,0,DIGCF_PRESENT|DIGCF_DEVICEINTERFACE); 
	if(PnPHandle != INVALID_HANDLE_VALUE) 
		{ 
 		for(HidDevice = 0; HidDevice <1024;  HidDevice++) 
			{ 
			DeviceInterfaceData.cbSize = 28; // Length of data structure in bytes 

			// check all HID device 
			Success = SetupDiEnumDeviceInterfaces(PnPHandle, 0, &HIDGuid, HidDevice, &DeviceInterfaceData); 
			if(Success == TRUE) 
			{ 
				HIDDeviceData.size = 5; 
				Success = SetupDiGetDeviceInterfaceDetail(PnPHandle, &DeviceInterfaceData,  
					 PSP_INTERFACE_DEVICE_DETAIL_DATA(&HIDDeviceData) 
					 , 256, &BytesReturned, 0); 
				if (Success == FALSE) 
				{ 
					MessageBox(NULL, "Could not find the system name for this HID device", "Error", MB_ICONSTOP); 
					HIDCleanup(); 
					return 0; 
				} 

				CleanFileHandle();
				HIDHandle = CreateFile(HIDDeviceData.path, 
					GENERIC_READ|GENERIC_WRITE, 
					FILE_SHARE_READ|FILE_SHARE_WRITE, 
					NULL, OPEN_EXISTING, 
					NULL, NULL); 

 				if(HIDHandle==INVALID_HANDLE_VALUE) continue; 

				// Get VID and PID 
				Success = HID_GetAttributes(HIDHandle, &HIDDevice); 
				if(Success && HIDDevice.VendorID==IFJET_VID && HIDDevice.ProductID==IFJET_PID)
					{
					memset(&mDev,0,sizeof(HID_DEVICE));

					// read from RadioJet-EEProm 
					// Get Manufacturers name if present 
					if(HID_GetManufacturerString(HIDHandle, buffer, sizeof(buffer))) 
						{ 
						i = 0; 
						tmp[1]=0; 
						strcpy(mDev.VendorName,"\0"); 
						while (buffer[i] != 0) //UNICODE to char 
							{  
							tmp[0]=buffer[i]; 
							strcat(mDev.VendorName,tmp); 
							i = i + 2; 
							} 
						} else strcpy(mDev.VendorName,"- not present -");  

					// read from RadioJet-EEProm
					// Get Product name if present 
					if(HID_GetProductString(HIDHandle, buffer, sizeof(buffer))) 
						{ 
						i = 0; 
						tmp[1]=0; 
						strcpy(mDev.ProductName,"\0"); 
						while (buffer[i] != 0) //UNICODE to char 
							{  
							tmp[0]=buffer[i]; 
							strcat(mDev.ProductName,tmp); 
							i = i + 2; 
							} 
						} else strcpy(mDev.ProductName,"- not present -");     

					
					// the standard HID-Access GetSerialNumberString does not work correctly, I know not why. ???
					// I think the HID routine will only have numbers, but there are also letters in it.
					
					// read from RadioJet-EEProm
					// Get Serial Number if present 
					if(HID_GetIndexedString(HIDHandle,3, buffer, 20)) 
						{ 
						i = 0; 
						tmp[1]=0; 
						strcpy(mDev.SerialNr,"\0"); 
						while (buffer[i] != 0) //UNICODE to char 
							{  
							tmp[0]=buffer[i]; 
							strcat(mDev.SerialNr,tmp); 
							i = i + 2; 
							} 
						} else strcpy(mDev.SerialNr,"- not present -");  
					
					strcpy(mDev.AudioDeviceName,"Generic USB Audio");

					//show all existing HID devices 
					//delete or comment it if you don't like this 
#ifdef _DEBUG
					char buf[256];
					sprintf(buf,"VID: 0x%04X PID: 0x%04X\nVendorName: %s  ProductName: %s SerialNr: %16s\n" 
						,HIDDevice.VendorID 
						,HIDDevice.ProductID 
						,mDev.VendorName 
						,mDev.ProductName 
						,mDev.SerialNr 
						); 
					TRACE(buf);
#endif

					
					ret=1; //if this is only an OpenDevice			
					break;
					}
 
				//Close device if this is not what we are searching for 
				CleanFileHandle();
 				} 
			} 
		}

	HIDCleanup();
	return ret;
} 
  
void RJ10_GPIO::CleanFileHandle()
{ 
	if(HIDHandle && HIDHandle!=INVALID_HANDLE_VALUE) CloseHandle(HIDHandle); 
	HIDHandle=NULL;
}

//######################################### 
void RJ10_GPIO::HIDCleanup() 
//######################################### 
{ 
 CleanFileHandle();
 if(PnPHandle) { SetupDiDestroyDeviceInfoList(PnPHandle); PnPHandle=NULL; } 
} 
 



