// RJ10FiFiDlg.h : header file
//

#if !defined(RJ10FIFI_DLG)
#define RJ10FIFI_DLG

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CRJ10FiFiDlg dialog

#include "FrqButton.h"
#include "MyClasses/MyEdit.h"
#include "MyClasses/MyPoti.h"
#include "MyClasses/MyButton.h"
#include "MyClasses/MyPeekMeter.h"
#include "MyClasses/MySMeter.h"
#include "RJ10-GPIO.h"
#include "IFScopeControl.h"


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	MyButton	b_src;
	MyButton	b_wik;
	MyButton	b_pro;
	CStatic		t_app;
	CFont		mFont;

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void GoSourceLink();
	afx_msg void GoWikiLink();
	afx_msg void GoProviderLink();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

class CRJ10FiFiDlg : public CDialog
{
// Construction
public:
	CRJ10FiFiDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRJ10FiFiDlg)
	enum { IDD = IDD_RJ10FIFI_DIALOG };
	CButton		m_gb1;
	CButton		m_gb2;
	FrqButton	m_FrqButton;
	BOOL		m_MM;
	CString		m_frqedit;
	MyEdit		e_frqedit;
IFScopeControl  m_IFctrl;
	MyButton	b_MinMax;	
	MyButton	b_IGC;
	MyButton	b_mode;
	MyButton	b_filter;

	MyButton	b_speaker;
	MyButton	b_stereo;
	MyButton	b_mixer;
	MyButton	b_manual;
	MyButton	m_symod;
	MyButton	b_gainset;

	MyPeekMeter	m_inpeek;
	MyPeekMeter	m_outpeek;
	MySMeter	m_smeter;

	MyPoti		poti_sql;
	MyPoti		poti_vol;
	MyPoti		poti_out;
	MyPoti		poti_gain;

	CStatic     drm_label;

	//}}AFX_DATA

	MyButton	b_fig[13];
	MyButton	b_mem[4];
	MyStateLED	led[4];

	RJ10_GPIO	myHID;

	int			RxAction, m_mode,drm_update,m_IGC,m_TOPMOST,m_memfrq[4],WinVersion;
	int			IFGainOff,IFGainLevel,SaveIFGainLevel,IFOutLevel,AFInLevel,AFOutLevel,DrawImmediately;
	int			m_filterwidth,m_sql,m_volume,m_spkON,m_stereoON;
	CRect		minRect,maxRect;
	float		DrawDelaySum,DrawDelayFac,DrawInputFac;



	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRJ10FiFiDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

public:
	int		m_frq,m_steps,LastDeviceCheck,ImOpen;

	void	SetEditFrq();
	void	SetFrq(int frq, int force=0);

	void	Adjust(int mm, int set=1);

	void	SetRadioModeButtons(int mode);
	void	SetFilterWidth(int width);
	void	SetIGC(int igc);
	void	SetVolume(int vol,int reset=0);
	void	SetSquelch(int sql);
	void	SetATT(int att);
	void	SetCHN(int chn);
	void	SetSystemModal(int modalmode);
	void	SetIFGain(int pos, int set=0);
	void	SetGain();
	void	SetAFOutLevel(int out); 
	void	SetStereo(int onoff);
	void	SetSpeaker(int onoff);
	void	MouseWheel(UINT nFlags, short zDelta,int RoundWidth);
	void	SuspendRX();
	void	ReActivateRX();
	void	RefreshDRMState();
	void	SetRepeatation(int repeat);


// Implementation
protected:
	HICON m_hIcon;
	// Generated message map functions
	//{{AFX_MSG(CRJ10FiFiDlg)
	afx_msg BOOL OnDeviceChange( UINT nEventType, DWORD dwData );
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSetMinOrMax();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnSetIGC();
	afx_msg void OnSetMode();
	afx_msg void OnSetFilter();
	afx_msg void OnSetGain();
	afx_msg void OnSetSystemModal();
	afx_msg void OnAudioMixer();
	afx_msg void OnSetSpeaker();
	afx_msg void OnSetStereo();
	afx_msg void OnManual();
	//}}AFX_MSG
	afx_msg void OnSetFrqMemory(UINT id);
	afx_msg void OnSetFrqDirect(UINT id);
	afx_msg LRESULT OnRightButton(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnFrqEditCR(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnIFInput(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT StartAction(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT ExtDeviceAdd(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT ExtDeviceRemoved(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUpdateSmeterButton(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT SetSMeter(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT SetSquelch(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnPotiChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnScopeOut(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMixCtrlChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT WaveOutVolumeChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT DrawFrqAction(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDRMChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQSHOWChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQCORRChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQSCALChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQOFFSChange(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(RJ10FIFI_DLG)
