////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "RJ10M-DLL.h"
#include "IFJet1102DLLThread.h"


COLORPACK	mCOL={0};


////////////////////////////////////////
//////////////// this is the first call 
/////////////////////////////////////////
//OpenReceiver, if PID==-1 then this app is conected as MINI-APP, else is ERROR
//----------------------------------------------------------------------------------------------------------------------------------
// !!!!prepare for the MainDialog.m_hWnd this must be all times the first action 
typedef BOOL	(WINAPI *DLL_OpenReceiver)(HWND mainwnd, char *maindir, UINT PID);
typedef void	(WINAPI *DLL_ProcessIFInput)(int process, WPARAM wp, LPARAM lp);	// the IF input message WM_PROCESS_IFIN will be porcessed by this App 
IFJet1102DLLThread *m_IFinpuThread=NULL;
volatile int		 IFinpuThreadWorkFlag=0;
volatile int		 IQinpuThreadWorkFlag=0;

typedef void	(WINAPI *DLL_CloseAll)();												//close Radio- and Audio- Device	

typedef int		(WINAPI *DLL_SetInputChannel)(int set);									//set the HI/LO Channel or automatic 
typedef int		(WINAPI *DLL_CheckDeviceChangings)(UINT nEventType, DWORD dwData);		//check device changings by message OnDeviceChange

typedef int		(WINAPI *DLL_SetRadioFrq)(int frq);						//set the radio frequency in Hz
typedef void	(WINAPI *DLL_SetRadioATT)(int att);						//set the radio attenuator (ON/OFF)
typedef void	(WINAPI *DLL_SetRadioIGC)(int igc);						//set the audio atomatic IF gain control 0-15 from fast to slow decay/attack
typedef void	(WINAPI *DLL_SetRadioIF)(int IF);						//set the radio filter band width
typedef void	(WINAPI *DLL_SetRadioMode)(int mode);					//set the radio demodulator mode LSB,USB,AM,FM...
typedef void	(WINAPI *DLL_SetRadioVolume)(int vol, int reset);		//set the radio volume 0-200; if reset=1 the reset the IGC Funktion
typedef int		(WINAPI *DLL_SetRadioSquelch)(int sql);					//set the radio squelch 0-160;

//only for RadioJet EEprom 
typedef void	(WINAPI *DLL_SetRadioFrqCorr)(int Hz,int onoff);		//set the Si570 Xtal-Frequency correcture in Hz
typedef void	(WINAPI *DLL_SetRadioFrqScale)(int Hz,int onoff);		//set the Si570 Xtal-Frequency Scale in Hz
typedef void	(WINAPI *DLL_SetDXFactor)(int factor,int onoff);		//set the DX-Gain Factor of the DX-Channel 
typedef void	(WINAPI *DLL_SetAudioSampleCorr)(int ppm,int onoff);	//set the adio sample freqency corrction in ppm 
typedef UINT	(WINAPI *DLL_GetEEpromInfo)(RJ10_EEROM_INFO *info);		//read the EEprom and create viewlable information
typedef int		(WINAPI *DLL_HandleEEpromValue)(int type, int set);		//Read, Write or Check the EEprom Data	
typedef int		(WINAPI *DLL_HandleRadioValue)(int type, int set);		//Set or Get radio parameter 
typedef void	(WINAPI *DLL_SetCalibrationMark)(int set);				//set an calibration signal in dBm, set a positive value, we set this to negative value 
typedef void	(WINAPI *DLL_SetCalibrationLine)(int set);				//switch the DoubleLines-Input on/off --> for two calibration signal lines

typedef BOOL	(WINAPI *DLL_OpenIFInput)(HWND audioin, DWORD IFJet1102DLLThread_ID);	//Open IF Input with your audio messages window and backprocess
typedef void	(WINAPI *DLL_ActivateIFInput)(int onOff);								//reactivate or deactivate IF Input after an device removement 0=reactivate 1=deactivate
typedef BOOL	(WINAPI *DLL_OpenAFOutput)(HWND audioout, char *name,  HWND DecEndWindow);	//Open AF Output with your audio messages window and as option the TX/RX decoder Window
typedef LRESULT	(WINAPI *DLL_MixerChange)(WPARAM hMixer,LPARAM dwControlID);//the routine for the IF-Input/Audio-Mixer handling

//#define SetMainVolume(level)			SetSpeakerVolume(-1,level)
#define SetWaveOutLeftLevel(level)		SetSpeakerVolume(-2,level)
#define SetWaveOutRightLevel(level)		SetSpeakerVolume(-3,level)
#define SetWaveOutMainLevel(level)		SetSpeakerVolume(-4,level)

typedef void	(WINAPI *DLL_SetSpeakerVolume)(int chn, int vol);	//set the main speaker volume 0-200; chn = 0=left and 1=right -1 = main
typedef void	(WINAPI *DLL_SetSpeakerOnOff)(int onof);			//switch for the main speaker on = -2 or off = -1  (0-4 intern specials --> see the decription on internet)
typedef void	(WINAPI *DLL_SetStereoOnOff)(int onof);				//switch the AudioOut to Stereo (only for DRM mode)
typedef void	(WINAPI *DLL_SetListenOn)();						//switch to listen / unfiltered input sound
typedef void	(WINAPI *DLL_SetWaveInLevel)(int lev);				//set the wave in level 0-200;
typedef void	(WINAPI *DLL_SetWaveOutVolume)(int vol);			//set the wave out volume 0-200;
typedef void	(WINAPI *DLL_SetWaveOn)();							//switch to wave / filtered output sound
typedef int 	(WINAPI *DLL_SetIFInputLevel)(int lev, int onOFF);	//set the IF-Input level and the currend onOFF state
typedef int 	(WINAPI *DLL_SetIFOutputLevel)(int lev);			//set the IF-Output level 0-200;

typedef float	(WINAPI *DLL_GetIFDrawData)(IF_DRAW_PARA *GetPara, int channel);	//get all the plot data and parameter of the current IF-Signal, -1 = default = current channel

typedef void	(WINAPI *DLL_DrawPotiLayout)(POTI_DRAWINFO *pinfo);		//draw poti design
typedef void	(WINAPI *DLL_InitRJ10Colors)(COLORPACK *colPack);		//init the RJ10 color design 

typedef BOOL    (WINAPI *DLL_OpenExtIQ)(EXT_IQRX *extRX);				//open the extern I/Q receiver for panorama view
typedef BOOL    (WINAPI *DLL_CloseExtIQ)();								//close the extern I/Q receiver 
typedef float	(WINAPI *DLL_GetExtIQDrawData)(IQ_DRAW_PARA *GetPara);	//get all the plot data and parameter of the current extern I/Q-Signal
typedef void	(WINAPI *DLL_SetExtIQData)(EXT_IQRX *extRX);			//set calibration data for the extern I/Q receiver (dBLevelOffset,XtalFrqCorr,XtalScalingCorr...)
typedef void	(WINAPI *DLL_PepareExtIQDataSet)(EXT_IQRX *extRX);		//you set the the IQ_type in EXT_IQRX data set,then call PepareExtIQDataSet 
																		//set befor extRX->IQ_type and if you set extRX->IQ_default=1 then you load a default set

//RIF = Radio Intermediate Frequency Files / in this case only for panorama view IQ data (for broad spectrum, but much less phase resolution)
typedef int		(WINAPI *DLL_IQ_Play)(char *filename, HWND RequestWindow, BOOL loop);   //play an RIF-File, like IF-Input
typedef void	(WINAPI *DLL_IQ_StopPlay)();						//stop playing and close the RIF-File
typedef BOOL	(WINAPI *DLL_IQ_Record)(char *filename, HWND RequestWindow); //record IF-Input to the RIF-File
typedef void	(WINAPI *DLL_IQ_StopRecord)();						//stop recording and close the RIF-File
typedef UINT	(WINAPI *DLL_IQ_GetPlayFileInfo)(char *filename,WAVEFORMATEX *fmt);		//Open RIF-File only for Info (no playing) / fmt->nChannels must be set / returned the FileLenght
typedef LONG	(WINAPI *DLL_IQ_SeekCurPlayFile)(LONG diff);		//seek on current position + diff
typedef LONG	(WINAPI *DLL_IQ_SeekSetPlayFile)(LONG pos);			//seek definitive on position
typedef UINT	(WINAPI *DLL_IQ_GetPlayFileLenght)();				//get the lenght of the currend open RIF-Record file
typedef void	(WINAPI *DLL_IQ_HaltPlay)(int state);				//set the Play halt state of the currend open RIF-Record file		1=halt 0=run
typedef void	(WINAPI *DLL_IQ_HaltRec)(int state);				//set the Record halt state of the currend open RIF-Record file		1=halt 0=run
typedef void	(WINAPI *DLL_IQ_LoopPlay)(int state);				//set the Play loop state of the currend open RIF-Record file		1=play continue 0=single times

//for DRM-Status
typedef IsoList		 &(WINAPI *DLL_GetLanguageList)();				//get the address pointer of the LanguageTable
typedef IsoList		 &(WINAPI *DLL_GetCountryList)();				//get the address pointer of the CountryTable
typedef CStringArray &(WINAPI *DLL_GetRegionsList)();				//get the address pointer of the RegionsList StringArray
typedef CStringArray &(WINAPI *DLL_GetDataAudioTypeList)();			//get the address pointer of the DataAudioTypes StringArray
typedef CStringArray &(WINAPI *DLL_GetCodecTypeList)();				//get the address pointer of the CodecTypes StringArray
typedef CStringArray &(WINAPI *DLL_GetProgramTypeList)();			//get the address pointer of the ProgramTypes  

typedef InDeviceList &(WINAPI *DLL_GetInputDeviceList)();			//get the address pointer of the Audio Device List 
typedef void (WINAPI *DLL_CopyRxStatus)(RX_SIGNAL_STATE *State, int readNew);	//get the DRM status info

HINSTANCE					m_DllHandle=NULL;

DLL_ProcessIFInput			ProcessIFInput=NULL;
DLL_OpenReceiver			OpenReceiver=NULL;
DLL_CloseAll				CloseAll=NULL;
DLL_SetInputChannel			SetInputChannel=NULL;
DLL_CheckDeviceChangings	CheckDeviceChangings=NULL;

DLL_SetRadioFrq				SetRadioFrq=NULL;
DLL_SetRadioATT				SetRadioATT=NULL;
DLL_SetRadioIF				SetRadioIF=NULL;
DLL_SetRadioVolume			SetRadioVolume=NULL;
DLL_SetRadioSquelch			SetRadioSquelch=NULL;
DLL_SetRadioIGC				SetRadioIGC=NULL;
DLL_SetRadioMode			SetRadioMode=NULL;

//only for RadioJet EEprom 
DLL_SetRadioFrqCorr			SetRadioFrqCorr=NULL;
DLL_SetRadioFrqScale		SetRadioFrqScale=NULL;
DLL_SetDXFactor				SetDXFactor=NULL;
DLL_SetAudioSampleCorr		SetAudioSampleCorr=NULL;
DLL_GetEEpromInfo			GetEEpromInfo=NULL;
DLL_HandleEEpromValue		HandleEEpromValue=NULL;
DLL_HandleRadioValue		HandleRadioValue=NULL;
DLL_SetCalibrationMark		SetCalibrationMark=NULL;
DLL_SetCalibrationLine		SetCalibrationLine=NULL;

DLL_OpenIFInput				OpenIFInput=NULL;
DLL_ActivateIFInput		    ActivateIFInput=NULL;
DLL_OpenAFOutput			OpenAFOutput=NULL;
DLL_MixerChange				MixerChange=NULL;

DLL_SetSpeakerVolume		SetSpeakerVolume=NULL;
DLL_SetSpeakerOnOff			SetSpeakerOnOff=NULL;
DLL_SetStereoOnOff			SetStereoOnOff=NULL;
DLL_SetListenOn				SetListenOn=NULL;
DLL_SetWaveInLevel			SetWaveInLevel=NULL;
DLL_SetWaveOutVolume		SetWaveOutVolume=NULL;
DLL_SetWaveOn				SetWaveOn=NULL;
DLL_SetIFInputLevel			SetIFInputLevel=NULL;
DLL_SetIFOutputLevel		SetIFOutputLevel=NULL;

DLL_GetIFDrawData			GetIFDrawData=NULL;
DLL_DrawPotiLayout			DrawPotiLayout=NULL;
DLL_InitRJ10Colors			InitRJ10Colors=NULL;

DLL_OpenExtIQ				OpenExtIQ=NULL;
DLL_CloseExtIQ				CloseExtIQ=NULL;
DLL_GetExtIQDrawData		GetExtIQDrawData=NULL;
DLL_SetExtIQData			SetExtIQData=NULL;
DLL_PepareExtIQDataSet		PepareExtIQDataSet=NULL;

DLL_GetLanguageList			GetLanguageList=NULL;
DLL_GetCountryList			GetCountryList=NULL;
DLL_GetProgramTypeList		GetProgramTypeList=NULL;
DLL_GetDataAudioTypeList	GetDataAudioTypeList=NULL;
DLL_GetCodecTypeList		GetCodecTypeList=NULL;
DLL_GetRegionsList			GetRegionsList=NULL;
DLL_GetInputDeviceList		GetInputDeviceList=NULL;
DLL_CopyRxStatus			CopyRxStatus=NULL;

DLL_IQ_Play					IQ_Play=NULL;
DLL_IQ_StopPlay				IQ_StopPlay=NULL;
DLL_IQ_Record				IQ_Record=NULL;
DLL_IQ_StopRecord			IQ_StopRecord=NULL;
DLL_IQ_GetPlayFileInfo		IQ_GetPlayFileInfo=NULL;
DLL_IQ_SeekCurPlayFile		IQ_SeekCurPlayFile=NULL;
DLL_IQ_SeekSetPlayFile		IQ_SeekSetPlayFile=NULL;
DLL_IQ_GetPlayFileLenght	IQ_GetPlayFileLenght=NULL;
DLL_IQ_HaltPlay     		IQ_HaltPlay=NULL;
DLL_IQ_HaltRec				IQ_HaltRec=NULL;
DLL_IQ_LoopPlay     		IQ_LoopPlay=NULL;

extern char myDIR[256];
void WINAPI FreeDLL()
{
	if(m_DllHandle) 
		{
		FreeLibrary(m_DllHandle);
		m_DllHandle=NULL;
		}
}

void WINAPI DeInstall_RJ10MDLL()
{
	if(m_DllHandle) 
		{
		if(m_IFinpuThread) 
			{
			 m_IFinpuThread->SuspendThread( );
			delete m_IFinpuThread;
			}
		m_IFinpuThread=NULL;
		CloseAll();
		FreeDLL();
		}
}

extern volatile int	StopFlag;
void WINAPI Suspend_RJ10MDLL()
{
	StopFlag=1;
	CloseAll();
	Sleep(100);
	if(m_IFinpuThread) 
		{
		while(IFinpuThreadWorkFlag && StopFlag<10)	
			{
			Sleep(100);
			StopFlag++;
			}

		m_IFinpuThread->SuspendThread();
		delete m_IFinpuThread;
		m_IFinpuThread=NULL;
		}

	m_IFinpuThread=NULL;
}


BOOL WINAPI Install_RJ10MDLL()
{
	if(m_DllHandle) return TRUE;
// Get the DLL 
	char buf[256];
	sprintf(buf,"%s\\RJ10.dll",myDIR);
	m_DllHandle= LoadLibrary(buf);
	if(!m_DllHandle) return FALSE;

	if(!(ProcessIFInput=(DLL_ProcessIFInput)GetProcAddress(m_DllHandle,"ProcessIFInput"))) goto err;
	if(!(OpenReceiver=(DLL_OpenReceiver)GetProcAddress(m_DllHandle,"OpenReceiver"))) goto err;
	if(!(CloseAll=(DLL_CloseAll)GetProcAddress(m_DllHandle,"CloseAll"))) goto err;
	if(!(OpenIFInput=(DLL_OpenIFInput)GetProcAddress(m_DllHandle,"OpenIFInput"))) goto err;
	if(!(ActivateIFInput=(DLL_ActivateIFInput)GetProcAddress(m_DllHandle,"ActivateIFInput"))) goto err;
	if(!(OpenAFOutput=(DLL_OpenAFOutput)GetProcAddress(m_DllHandle,"OpenAFOutput"))) goto err;
	if(!(MixerChange=(DLL_MixerChange)GetProcAddress(m_DllHandle,"MixerChange"))) goto err;

	if(!(SetSpeakerVolume=(DLL_SetSpeakerVolume)GetProcAddress(m_DllHandle,"SetSpeakerVolume"))) goto err;
	if(!(SetSpeakerOnOff=(DLL_SetSpeakerOnOff)GetProcAddress(m_DllHandle,"SetSpeakerOnOff"))) goto err;
	if(!(SetStereoOnOff=(DLL_SetStereoOnOff)GetProcAddress(m_DllHandle,"SetStereoOnOff"))) goto err;
	if(!(SetListenOn=(DLL_SetListenOn)GetProcAddress(m_DllHandle,"SetListenOn"))) goto err;
	if(!(SetWaveInLevel=(DLL_SetWaveInLevel)GetProcAddress(m_DllHandle,"SetWaveInLevel"))) goto err;
	if(!(SetWaveOutVolume=(DLL_SetWaveOutVolume)GetProcAddress(m_DllHandle,"SetWaveOutVolume"))) goto err;
	if(!(SetWaveOn=(DLL_SetWaveOn)GetProcAddress(m_DllHandle,"SetWaveOn"))) goto err;
	if(!(SetIFInputLevel=(DLL_SetIFInputLevel)GetProcAddress(m_DllHandle,"SetIFInputLevel"))) goto err;
	if(!(SetIFOutputLevel=(DLL_SetIFOutputLevel)GetProcAddress(m_DllHandle,"SetIFOutputLevel"))) goto err;


	if(!(SetInputChannel=(DLL_SetInputChannel)GetProcAddress(m_DllHandle,"SetInputChannel"))) goto err;
	if(!(CheckDeviceChangings=(DLL_CheckDeviceChangings) GetProcAddress(m_DllHandle,"CheckDeviceChangings"))) goto err;

	if(!(SetRadioFrq=(DLL_SetRadioFrq)GetProcAddress(m_DllHandle,"SetRadioFrq"))) goto err;
	if(!(SetRadioATT=(DLL_SetRadioATT)GetProcAddress(m_DllHandle,"SetRadioATT"))) goto err;
	if(!(SetRadioMode=(DLL_SetRadioMode)GetProcAddress(m_DllHandle,"SetRadioMode"))) goto err;
	if(!(SetRadioIGC=(DLL_SetRadioIGC)GetProcAddress(m_DllHandle,"SetRadioIGC"))) goto err;
	if(!(SetRadioIF=(DLL_SetRadioIF)GetProcAddress(m_DllHandle,"SetRadioIF"))) goto err;
	if(!(SetRadioVolume=(DLL_SetRadioVolume)GetProcAddress(m_DllHandle,"SetRadioVolume"))) goto err;
	if(!(SetRadioSquelch=(DLL_SetRadioSquelch)GetProcAddress(m_DllHandle,"SetRadioSquelch"))) goto err;


/*only for RadioJet EEprom 
	if(!(SetRadioFrqCorr=(DLL_SetRadioFrqCorr)GetProcAddress(m_DllHandle,"SetRadioFrqCorr"))) goto err;
	if(!(SetRadioFrqScale=(DLL_SetRadioFrqScale)GetProcAddress(m_DllHandle,"SetRadioFrqScale"))) goto err;
	if(!(SetDXFactor=(DLL_SetDXFactor)GetProcAddress(m_DllHandle,"SetDXFactor"))) goto err;
	if(!(SetAudioSampleCorr=(DLL_SetAudioSampleCorr)GetProcAddress(m_DllHandle,"SetAudioSampleCorr"))) goto err;
	if(!(GetEEpromInfo=(DLL_GetEEpromInfo)GetProcAddress(m_DllHandle,"GetEEpromInfo"))) goto err;
	if(!(HandleEEpromValue=(DLL_HandleEEpromValue)GetProcAddress(m_DllHandle,"HandleEEpromValue"))) goto err;
	if(!(HandleRadioValue=(DLL_HandleRadioValue)GetProcAddress(m_DllHandle,"HandleRadioValue"))) goto err;
	if(!(SetCalibrationMark=(DLL_SetCalibrationMark) GetProcAddress(m_DllHandle,"SetCalibrationMark"))) goto err;
	if(!(SetCalibrationLine=(DLL_SetCalibrationLine) GetProcAddress(m_DllHandle,"SetCalibrationLine"))) goto err;
*/
	if(!(GetIFDrawData=(DLL_GetIFDrawData)GetProcAddress(m_DllHandle,"GetIFDrawData"))) goto err;
	if(!(DrawPotiLayout=(DLL_DrawPotiLayout)GetProcAddress(m_DllHandle,"DrawPotiLayout"))) goto err;
	if(!(InitRJ10Colors=(DLL_InitRJ10Colors)GetProcAddress(m_DllHandle,"InitRJ10Colors"))) goto err;

	if(!(OpenExtIQ=(DLL_OpenExtIQ)GetProcAddress(m_DllHandle,"OpenExtIQ"))) goto err;
	if(!(CloseExtIQ=(DLL_CloseExtIQ)GetProcAddress(m_DllHandle,"CloseExtIQ"))) goto err;
	if(!(GetExtIQDrawData=(DLL_GetExtIQDrawData)GetProcAddress(m_DllHandle,"GetExtIQDrawData"))) goto err;
	if(!(SetExtIQData=(DLL_SetExtIQData)GetProcAddress(m_DllHandle,"SetExtIQData"))) goto err;
	if(!(PepareExtIQDataSet=(DLL_PepareExtIQDataSet)GetProcAddress(m_DllHandle,"PepareExtIQDataSet"))) goto err;

	if(!(GetCountryList=(DLL_GetCountryList)GetProcAddress(m_DllHandle,"GetCountryList"))) goto err;
	if(!(GetLanguageList=(DLL_GetLanguageList)GetProcAddress(m_DllHandle,"GetLanguageList"))) goto err;
	if(!(GetProgramTypeList=(DLL_GetProgramTypeList)GetProcAddress(m_DllHandle,"GetProgramTypeList"))) goto err;
	if(!(GetDataAudioTypeList=(DLL_GetDataAudioTypeList)GetProcAddress(m_DllHandle,"GetDataAudioTypeList"))) goto err;
	if(!(GetCodecTypeList=(DLL_GetCodecTypeList)GetProcAddress(m_DllHandle,"GetCodecTypeList"))) goto err;
	if(!(GetRegionsList=(DLL_GetRegionsList)GetProcAddress(m_DllHandle,"GetRegionsList"))) goto err;
	if(!(GetInputDeviceList=(DLL_GetInputDeviceList)GetProcAddress(m_DllHandle,"GetInputDeviceList"))) goto err;
	if(!(CopyRxStatus=(DLL_CopyRxStatus)GetProcAddress(m_DllHandle,"CopyRxStatus"))) goto err;

	if(!(IQ_Play=(DLL_IQ_Play)GetProcAddress(m_DllHandle,"IQ_Play"))) goto err;
	if(!(IQ_StopPlay=(DLL_IQ_StopPlay)GetProcAddress(m_DllHandle,"IQ_StopPlay"))) goto err;
	if(!(IQ_Record=(DLL_IQ_Record)GetProcAddress(m_DllHandle,"IQ_Record"))) goto err;
	if(!(IQ_StopRecord=(DLL_IQ_StopRecord)GetProcAddress(m_DllHandle,"IQ_StopRecord"))) goto err;
	if(!(IQ_SeekCurPlayFile=(DLL_IQ_SeekCurPlayFile)GetProcAddress(m_DllHandle,"IQ_SeekCurPlayFile"))) goto err;
	if(!(IQ_SeekSetPlayFile=(DLL_IQ_SeekSetPlayFile)GetProcAddress(m_DllHandle,"IQ_SeekSetPlayFile"))) goto err;
	if(!(IQ_GetPlayFileInfo=(DLL_IQ_GetPlayFileInfo)GetProcAddress(m_DllHandle,"IQ_GetPlayFileInfo"))) goto err;
	if(!(IQ_GetPlayFileLenght=(DLL_IQ_GetPlayFileLenght)GetProcAddress(m_DllHandle,"IQ_GetPlayFileLenght"))) goto err;
	if(!(IQ_HaltPlay=(DLL_IQ_HaltPlay)GetProcAddress(m_DllHandle,"IQ_HaltPlay"))) goto err;
	if(!(IQ_HaltRec=(DLL_IQ_HaltRec)GetProcAddress(m_DllHandle,"IQ_HaltRec"))) goto err;
	if(!(IQ_LoopPlay=(DLL_IQ_LoopPlay)GetProcAddress(m_DllHandle,"IQ_LoopPlay"))) goto err;

	m_IFinpuThread = (IFJet1102DLLThread*) AfxBeginThread(RUNTIME_CLASS(IFJet1102DLLThread), 16 ,0, CREATE_SUSPENDED);
//	m_IFinpuThread->ResumeThread();

	return TRUE;

err:
	FreeDLL();
	return FALSE;
}
