#if !defined(FIFI_RJ10_DLL_ADAPTION)
#define FIFI_RJ10_DLL_ADAPTION

#pragma pack(push)
#pragma pack(1)

#include <afxtempl.h>
#include <mmsystem.h>
#include "IFJet1102DLLThread.h"
//global RJ10 messages  

#define IF_SAMPLE_FRQ			48000
#define	IF_SAMPLE_NUM			2048
#define AF_SAMPLE_FRQ			24000
#define	AF_SAMPLE_NUM			2048
#define IF_GAIN_FACTOR			61

//amplChannel switch to HI or LO Channel
#define		DX_CHN		0		//amplified left channel 
#define		RX_CHN		1		//normal unplugged right channel (amplifire off)
#define     AUTO_CHN	2		//automatic  channel selection
#define     GET_CHN		-1		//which channel is active ?

//IQ-Recoder mode types
#define RECORD_LSB		0x40
#define RECORD_USB		0x80
#define RECORD_CW		0xC0
#define RECORD_AM		0x00
#define RECORD_FM		0xA0
#define RECORD_WFM		0x60
#define RECORD_DRM		0x20
#define RECORD_AMS		0xE0
#define RECORD_TYPEMASK 0x1F
#define RECORD_MODEMASK 0xE0


#define WM_POTICHANGE		(WM_USER+3)
#define WM_DRAW_IF			(WM_USER+17)
#define WM_BLOCKING_INPUT	(WM_USER+21)	//blocking the input thread
#define WM_PROCESS_IQIN		(WM_USER+22)	//we have an new IQ-Input-Block of the extern input device for parorama view
#define WM_PROCESS_IFIN		(WM_USER+23)	//we have an new IF-Input-Block of the input device for Filter and so one
#define WM_GET_SPECTRUM		(WM_USER+26)	//new IF-WidthBand-SpectrosScope data are avalable to view / plot

#define WM_MYUSER			(WM_USER+7400)
#define DLL_USER			(WM_USER+7800)

#define WM_HID_JET_ADD		(WM_MYUSER+60)
#define WM_HID_JET_REMOVE	(WM_MYUSER+61)
#define WM_HID_JET_GPI		(WM_MYUSER+62)

#define WM_HID_EXT_ADD		(WM_MYUSER+70)  //the callback messages: the receiver has been inserted and becomes available
#define WM_HID_EXT_REMOVE	(WM_MYUSER+71)	//the callback messages: the receiver has been removed and is no more available

#define WM_EXTIQ_ATT_CHNG	(WM_MYUSER+75)	//the ATT has changet 
#define WM_EXTIQ_AGC_CHNG	(WM_MYUSER+76)  //the AGC has changet 
#define WM_EXTIQ_PRE_CHNG	(WM_MYUSER+77)	//the PreAmplifiere changet
#define WM_EXTIQ_DIT_CHNG	(WM_MYUSER+78)	//the Dithering has changed 
#define WM_EXTIQ_NB_CHNG	(WM_MYUSER+79)	//the NoisBlanker has changed
#define WM_EXTIQ_FIL_CHNG	(WM_MYUSER+80)	//the FilterSelect has changed
#define WM_EXTIQ_SMPL_CHNG	(WM_MYUSER+81)	//the SampleRate has changed
#define WM_EXTIQ_INFO_CHNG	(WM_MYUSER+82)	//the InfoField has changed
#define WM_EXTIQ_OFFS_CHNG	(WM_MYUSER+83)	//the dBOffset has changed
#define WM_EXTIQ_CORR_CHNG	(WM_MYUSER+84)	//the FreqCorrecture has changed
#define WM_EXTIQ_SCAL_CHNG	(WM_MYUSER+85)	//the ScaleCorrecture has changed
#define WM_EXTIQ_SHOW_CHNG	(WM_MYUSER+86)  //the GUI of the extern receiver calls this message if it is hidden or shown

#define WM_EDIT_CR			(WM_MYUSER+92)	
#define WM_RBCLICK			(WM_MYUSER+163)	//right button click

#define WM_DRAW_FRQ			(DLL_USER+88)
#define WM_START_ACTION		(DLL_USER+95)
#define WM_DRM_STATE_CHANGE	(DLL_USER+97)	//DRM State changed		DLL -> PostMessage(MAIN_hWnd,WM_DRM_STATE_CHANGE,(WPARAM)IFSignalLevel,(LPARAM)StateFlags);
#define WM_SET_OUTPEAK		(DLL_USER+100)	//for out peeakmeter	DLL -> PostMessage(AUDIO_hWnd,WM_SET_OUTPEAK,(WPARAM)output speaker peeekmeter value,NULL);
#define WM_SET_INPEAK		(DLL_USER+101)	//for in peeakmeter		DLL -> PostMessage(AUDIO_hWnd,WM_SET_INPEAK,(WPARAM)input peeekmeter value,NULL);
#define WM_SET_SMETER		(DLL_USER+102)	//SMeterChange			DLL -> PostMessage(MAIN_hWnd,WM_SET_SQLPEAK,(WPARAM)signalvalue,NULL);
#define WM_SET_SQLLED		(DLL_USER+103)	//SquelchChange			DLL -> PostMessage(MAIN_hWnd,WM_SET_SQLLED,(WPARAM)onoff,NULL);

//Wave Output Volume is the Wave slider of the output mixer control
#define WM_SET_WAVEVOLUME	(DLL_USER+106)	//WaveOutVolumeChanged	DLL -> PostMessage(AUDIO_hWnd,WM_SET_WAVEVOLUME,(WPARAM)WaveOutVolume,(LPARAM)waveswitch);

//WaveInPoti is an intern wave amplitute limiter
#define WM_SET_WAVELEVEL	(DLL_USER+107)	//WaveInLevelChanged	DLL -> PostMessage(AUDIO_hWnd,WM_SET_WAVELEVEL,(WPARAM)WaveInVolume,(LPARAM)waveswitch);

//InLevel is the LineIn or Microfone slider of the input mixer control
#define WM_SET_IF_INLEVEL	(DLL_USER+109)	//LineIn/Gain Level changed	 DLL -> PostMessage(AUDIOIN_hWnd,WM_SET_IF_INLEVEL,(WPARAM)IFGainLevel,(LPARAM)IFGainOff); 
//InLevel is the LineIn or Microfone slider of the input mixer control
#define WM_SET_IF_OUTLEVEL	(DLL_USER+110)	//LineOut/Gain Level changed DLL -> PostMessage(AUDIOOUT_hWnd,WM_SET_IF_OUTLEVEL,(WPARAM)IFInputLevel,(LPARAM)IFInputLevel);


#define WM_WAVEFILE_CLOSE	(DLL_USER+139)
#define WM_WAVEFILE_DBLCLKB	(DLL_USER+140)
#define WM_WAVEFILE_CHANGED	(DLL_USER+141)

#define WM_UDP_SMETER_DBSM	(DLL_USER+150)

#define WM_IF_FILE_WRITE	(DLL_USER+260)
#define WM_IF_FILE_READ		(DLL_USER+261)
#define WM_IF_FILE_REWIND	(DLL_USER+262)
#define WM_IF_FILE_CLOSE	(DLL_USER+263)


typedef struct	{
				//get data para, access references for two channels

				//only data output pointer or last status
				float	*RawData[2];	//the address of the raw data buffer
				float	*MagData[2];	//the address of the magitude data buffer
				float	SignalLevel;	//current dBm value of signal strenght in the range of current IF-filter
				float	SNRLevel;		//current dB value of SNR in the range of current IF-filter
				float	MaxLevel;		//current max level in dB
				float	MinLevel;		//current min level in dB
				float	MagMax;			//current max value of magnitude
				float	MagMin;			//current min value of magnitude
				float	MagMean;		//current mean value of magnitude
				float	RawMean;		//current mean value of raw data
				float	RawMax;			//current max value of raw data
				float	IFPeek;			//current IF-Signal peek in dB
				float	AFPeek;			//current AF-Signal peek in dB
				//MRSS
				//only data output pointer or last status
				USHORT	*curLine;			//pointer to the currend buffer of magitude values
				USHORT	*SpecDataBuffer;	//the buffer to the Spectrum Magnitude 
				int		MaxBufferLines;		//the maximum lines Spectrum Magnitude
				int		getPointer;			//the counter of the total input lines
				}IF_DRAW_PARA;

typedef struct 	{
				float        re;
				float        im;
				}SCplx;

typedef struct	{
				//get draw data from extern IQ-Receiver
				int		getPointer;			//the pointer for get from InputBuffer
				SCplx	*RawData;			//the address of the raw data buffer
				int		RawSize;			//the max size of the RawData
				float	*MagData;			//the address of the magitude data buffer
				int		MagSize;			//the max size of the MagData
				float	SignalLevel;		//current dBm value of signal strenght in the range of current IF-filter
				float	SNRLevel;			//current dB value of SNR in the range of current IF-filter
				float	MaxLevel;			//current max level in dB
				float	MinLevel;			//current min level in dB
				float	MagMax;				//current max value of magnitude
				float	MagMin;				//current min value of magnitude
				float	MagMean;			//current mean value of magnitude
				float	RawMax;				//current max value of raw data
				float	RawMin;				//current min value of raw data
				float	RawMean;			//current mean value of raw data
				float	IFPeek;				//current IF-Signal peek in dB
				float	AFPeek;				//current AF-Signal peek in dB
				float	FMMagMax;			//current max value of magnitude
				float	FMMagMin;			//current min value of magnitude
				float	*FMMag;				//the address of the FM audio magitude data buffer
				int		FMswitch;			//demodulate the FM audio and put it into *FMMag 
				char	*RadioText;
				char	*ProgText;
				}IQ_DRAW_PARA;

typedef struct	{
				int		ReceiverMode;		//0=RECMODE_DRM, 1=RECMODE_AM, 2=RECMODE_NONE 	
				BYTE	DRMState;			//Decoder RX AcquiState //AS_WITH_SIGNAL
				BYTE	MSCState;			//Decoder RX state  MSC 	
				BYTE	FACState;			//Decoder RX state  FAC
				BYTE	SDCState;			//Decoder RX state	SDC 

				BYTE	FSYNCState;			//frame sync state  
				BYTE	TSYNCState;			//time sync state 
				BYTE    IOState;			//I/O state
				BYTE	AcquiState;			

				BYTE	RobMode;
				BYTE	SpectrumOccup;
				BYTE	SymbolInterlMode;
				BYTE	SDCCodingScheme;

				BYTE	MSCCodingScheme;			
				BYTE	activeService;		//ACT_SERVICE_1-4 market
				BYTE	iCurSelAudioServ;	//the current selected services
				BYTE    bReserve;			///may be expanisions ... it's not free for any use

				int		IFSignalLevel;		//last Signal Level State
				int		iServiceID;			//the ID of the Service
				int		LanguageIdx;		//received index of the language list
				int		CountryIdx;			//received index of the country list
				int		DataAudioTypeIdx;	//received index of the DataAudio StringArray
				int		ProgrammTypeIdx;	//received index of the program type list
				int		CodecTypeIdx;		//received index of the codec type StringArray
				int		iCurSamROffs;
				int		iPartA;
				int		iPartB;
				int		iNumAudioService;
				int		iNumDataService;
				time_t	rxTime;
				int		iReserve[9];		//may be expanisions ... it's not free for any use

				double	rIFSigStr;			//IF- Input level meter
				double	BitRateKbps;		//Service  Bit-rate 
				double	rPartABLenRat;		//in percent %
				float	rSNR;
				float	rMER;
				float	rWMER;
				float	rSigmaEstimate;
				float	rMinDelay;
				float	rCurSamROffs;
				float   rDCFrequency;
				char	TextMessages[512];  //the big text messages is presend	DRM_AC_... 
				char	ServiceLabel[64];
				char	Call[16];
				char    QTHloc[16];
				}RX_SIGNAL_STATE; 

typedef struct	{
				COLORREF background;	//GetSysColor(COLOR_BTNFACE);
				COLORREF knobface;		//GetSysColor(COLOR_3DSHADOW);
				COLORREF light;			//GetSysColor(COLOR_3DLIGHT);	
				COLORREF vlight;		//light + 10% luminace
				COLORREF dark;			//GetSysColor(COLOR_3DSHADOW);
				COLORREF vdark;			//GetSysColor(COLOR_3DDKSHADOW);
				COLORREF btxt;			//GetSysColor(COLOR_BTNTEXT);	

				COLORREF scopemark;		//red mark color 
				COLORREF scope_B;		//scope background
				COLORREF scope_L;		//background +5% luminace
				COLORREF scope_P;		//background +10% luminace
				COLORREF scope_line;	//GetSysColor(COLOR_BTNTEXT);
				
				CBrush	*scope_back;	//pattern brusch of spectrum backgrund
				CBrush	*scope_range;	//pattern brusch of filter range
				}COLORPACK;

typedef struct	{
				DRAWITEMSTRUCT	*lpDIS;
				COLORREF		m_facecol;  //the color of the knop default is this COL_KNOBFACE
				COLORREF		m_ledcol;	//the color of the LED (if in use)
				int				m_flags;
				int				m_sval;
				int				m_srange;
				int				m_markpoint;
				int				m_mark;
				int				lfHeight;
				char			Title[64];
				char			ExtraText[64];
				}POTI_DRAWINFO;

#ifndef RJ10_EEP_INFO
#define RJ10_EEP_INFO
typedef struct	{
				USHORT			WorkFlags;			//flags for the intern working		
				// 0 = EEpron is Empty  
				// BIT-0  (0x0001) = EEprom / Device is present
				// BIT-1  (0x0002) = read error
				// BIT-2  (0x0004) = write error

				// BIT-13 (0x2000) = +Software Support Option 
				// BIT-14 (0x4000) = +TX Option 
				// BIT-15 (0x8000) = +RX Option 

				// if non BIT-15,14,13  (WorkFlags&0xE000)==NULL,
				// then = device is only a minimal factory version - no intern firmware installed for PnP-Callback funktions

				USHORT			VID;				//vendor ID
				USHORT			PID;				//pruduct ID
				USHORT			StartUpFrq;			//StartUpFrequency of SI570 0=UNUSED 1=15.00 MHz 2=56.32 MHz
				time_t			CreationDate;		//date of the factory calibration
				time_t			RegistryDate;		//date of the regitration by Internet
				
				short			AudioCorrecture;	// the audio chip own individual cristall clock difference offset to correct size of fax or sstv slant
				short			FreqCorrecture;		// the receiver chip own individual frequency offset
				short			ScaleCorrecture;	// the chip own individual frq scaling distance (difference from Low-Frq to Hi-Frq in Hz)
				short			DxFactor;			// the DXFactor of the DX-Channel

				//for reset 
				short			AC;					// factory default AudioCorrecture;	
				short			FC;					// factory default FreqCorrecture;	
				short			SC;					// factory default ScaleCorrecture;	
				short			DX;					// factory default DxFactor;	

				char			DeviceKey[28];		//device  ID  (64 Bit key of creation date & serial number for identification)
				char			PROKey[28];			//program ID  (64 Bit key of creation date & random number for update service)
				UINT			PPre;				//program ID  (+32 Bit prefix of PROKey) 				
				char			DATKey[28];			//data    ID  (64 Bit key of creation date & random number for data service)
				UINT			DPre;				//data    ID  (+32 Bit prefix of DATKey) 				
				char			OptionString[64];	
				char			ManufactString[32];
				char			ProductString[32];
				char			SerialNrString[16];
				}RJ10_EEROM_INFO;
#endif

typedef struct	{
				HWND		SpectrumCtrlWin;//MessagesWindow to control the spectrum mode
				HWND		messageWin;		//Window for Messages
				HWND		sendDBLCLICK;	//Window for Messages WM_FRQ_DBLCLICK
				HWND		sendSCALEOPT;	//Window for Messages WM_SCALE_MOVE,WM_SCALE_UP,
				HWND		sendMOUSEWHEEL;	//Window for Messages WM_UPDATE_MWH

				int			m_mark;		
				int			m_fftmarklo;
				int			m_fftmarkhi;
				int			m_fftrangelo;
				int			m_fftrangehi;
				int			m_scalemarklo;
				int			m_scalemarkhi;
				int			m_centermark;	//(Center Mark) only for drawing the mark lines
				int			m_IFCenter;		//the IF-Center for drawing filter curve and decode offset
				int			m_ShiftCenter;
				int			m_FCenter;		//filter center frq
				int			m_FOffset;		//filter offset from FCenter
				int			m_FWidth;		//filter width
				int			m_IFOffset;		//offset (if DEMO, then we use this)
				int			m_Fcenter1;		//1. filter center
				int			m_Fcenter2;		//2. filter center (on RTTY)

				int			m_radiofrq;		//the IF-Radio frequency 
				int			m_radiomode;	//the IF-Radio mode (USB,LSB...)	

				int			m_style;		//spectrum analyser or scope style
				int			m_FaceType;		//Style and Face type like IF_MARK_FLAG
				int			m_lo;			//frequency band start 
				int			m_hi;			//frequency band end
				COLORREF	m_TextColor;
				int			m_StartPos;
				int			m_BandWidth;
				int			topStartPos;
				int			topBandWidth;
				int			topCenter;
				int			topCentermark;

				short		m_ampl;			//the amplitude poti value
				short		m_level;		//the lower level of the logarithmic scale (on normale Mode)
				short		m_amplCut;		//cut the amplitude in Magnitude-Mode on 3D-Landscape
				short		topAmpl;		//the topView amplitude poti value
				short		topLevel;		//the topView lower level of the logarithmic scale
				short		topStyle;		//
				short		topYPos;
				short		m_contrast;		//the contrast poti value
				short		m_bright;		//the brightnes poti value
				short		m_intensity;	//the mixline intensity poti value
				UINT		splitYPos:16;	//splitted spectrum Y-position 
				UINT		splitReserve:16;

				BYTE		m_DecScale;		//the spreading of the decibel scale (dB-Scale)
				BYTE		m_LargeScale;	//default large of m_DecScale
				BYTE		m_SmallScale;	//default small of m_DecScale
				BYTE		m_DecLevel;		//the lower level of the decibel scale (on measurement Mode)
				BYTE		m_LargeLevel;	//default large of m_DecLevel
				BYTE		m_SmallLevel;	//default small of m_DecLevel

				BYTE		m_WFMScaleSave;
				BYTE		m_WFMLevelSave;
				BYTE		m_WFMScale;
				BYTE		m_WFMLevel;
				UINT		m_WFMwidthSave:16;	//width poti 1/10 = window cut width
				UINT		m_WFMposSave:16;	//pos poti 1/10	  = window cut LO-pos 
				UINT		m_WFMwidth:16;		
				UINT		m_WFMpos:16;
				UINT		m_WFMstyleSave;
				UINT		m_WFMstyle;
				UINT		m_WFMtopYPosSave:8;
				UINT		m_WFMtopYPos:8;
				UINT		m_WFMreserveBits:16;
				UINT		m_reserve[5];	//reserve

				BYTE		m_ColorFlag;	//flag for Time Spectrum Colors ....
				USHORT		m_TextMark;		//see -> IF_MARK_LABEL_NAME --> PANEL_RIGHT_OFF  0x80
				int			m_frq;			//if frequency scale else =0
				UINT		dectype:6;		//type of current decoder dialog type  
				UINT		decmode:6;		//type of current decoder mode
				UINT		radioreserve:20;//the rest of radio bits 

				BYTE		m_repeatation;	//the repetation of drawing per secunde
				BYTE		m_smoothing;	//the smooth drawing delay  level

				UINT		m_onoff:1;		
				UINT		topOFF:1;		//1=dont draw the topView
				UINT		WFMtopOFFSave:1;
				UINT		WFMtopOFF:1;
				UINT		m_TSsmooth:1;
				UINT		m_filterout:1;
				UINT		m_setfilter:1;
				UINT		m_createfilter:1;
				UINT		m_curveonoff:1;
				UINT		m_delayonoff:1;
				UINT		m_finetune:4;	//1=fine tuningin options
				UINT		m_SpectrumMode:4;
				UINT		m_channel:4;	//if channel selction then ist this the number 0 mono  bit-0 = right  bit-1 = left  3=stereo
				UINT		m_draw_frq_label:1;
				UINT		m_stored:1;		//indicator for swap IF and AF Page		1= IFPara was stored  0=the data was restored or empty
				UINT		m_splitstyle:2; //splitted time & line sprectrum horizontal (never in combination of IF_STYLE_TML)
				UINT		m_fillline:1;	//fill the signal line 
				UINT		m_smUpDown:1;	//scale moving bottom up down 
				UINT		flag_reserve:4;
				char		IFfilter_name[16];
				}IF_ANA_STYLE;

typedef struct	{
				int     m_sample_freq;
				int		m_sample_num;
				int		m_lo;
				int		m_hi;
				int		m_mi;
				int		m_maxwidth;	
				int		width;
				int		pos;
				int		potifilt;
				int		IFLines;
				IF_ANA_STYLE ViewStyle;
				}IF_FILTER_PARA;


//extern reciver mode = sample freq, samples per block, 
#define ExtIO_MODE_0	0	//  96000, 8192	== default
#define ExtIO_MODE_1	1	//  48000, 4096
#define ExtIO_MODE_2	2	//  96000, 8192
#define ExtIO_MODE_3	3	// 192000, 16384

//extern reciver type 
#define ExtIO_TYPE_0	0	//  RadioJet 1102
#define ExtIO_TYPE_1	1	//  FiFi-SDR control onyl

//--------------------------------------------------------
//the folowing types we using only in the RadioJet-Program
//--------------------------------------------------------
//extern reciver type for panorama view and multi range spectrum scanning 
#define ExtIO_TYPE_NON		127	//  no receiver selected
#define ExtIO_TYPE_PANO		128	//  flag for intern RadioJet panorama control
#define ExtIO_TYPE_FIFI		129	//  FiFi-SDR 
#define ExtIO_TYPE_PAPP		130	//	Pappradio 
#define ExtIO_TYPE_FDM1		131	//	ELAD FDM-S1
#define ExtIO_TYPE_IQ14		132	//	SDR-IQ/SDR-14
#define ExtIO_TYPE_PMSDR	133 //  PM-SDR
#define ExtIO_TYPE_PERSEUS	134	//	Perseus
#define ExtIO_TYPE_G31DCD	135 //  Excalibur
#define ExtIO_TYPE_G33DCD	136 //  Excalibur Pro
#define ExtIO_TYPE_RTL2832	137 //  RTL2832-Stick


typedef struct	{
				UINT		IQ_freq:25;			//samples per secunde  normal is 48/96/192 KHz 
				UINT		IQ_downsampling:2;	//1=divided by 2, 2 by 4 und 3 by 8
				UINT		IQ_multiplex:1;
				UINT		IQ_spow:4;			//samples per block+6; (min=6,max=21 --> (as power of 2) 10=1024 (1<<10) or 12=4096 (1<<12); 
				}SAMPLE_SET;

//for RTL2832 Panorama 
typedef struct
{
				BYTE	 InfoField[502-160];
		    SAMPLE_SET   SampleSets[8];	//=160
				USHORT	 GainValues[32];//=128		{ 0, 9, 14, 27, 37, 77, 87, 125, 144, 157, 166, 197, 207, 229, 254, 280, 297, 328, 338, 364, 372, 386, 402, 421, 434, 439, 445, 480, 496,0,0,0 };
				char	 DeviceName[32];//=64		last selected RTL Device Name 
				UINT	 VID:16;		//#32=32:	currend Vendor ID
				UINT	 PID:16;		//#16		currend Produkt ID
				UINT	 gainValue:9;	//#32=28:	last RF-gain value	max=512
				UINT	 gainIndex:5;	//#23		RF-gain tabel index	max=32
				UINT	 gainMax:5;		//#18		RF-gain maximum gain table size
				UINT	 SampleType:2;	//#13		0=quadrature 1=I-branch 2=Q-branch
				UINT	 AGC_Tuner:1;	//#11		on=1 off=0
				UINT	 AGC_RTL:1;		//#10		on=1 off=0
				UINT	 TuningOffset:1;//# 9		on=1 off=0
				UINT	 audioOUT:2;	//# 8		reflection of IQ_RADIO_PARAMETER ---> 0= give not the audio out, 1=by left channel, 2=right channel, 3=both channel in stereo
				UINT	 StereoMode:1;	//# 6		stereo = 1  and mono =0
				UINT	 reserveFlags:5;//#	5	
				int		 FreqOffset;	//=24:		converting frequency offset to the RTL-Tuner
				UINT	 msgRTL;		//=20:	
				int		 NCOPosFreq:30;	//=16:28	positon of the demudolation frequency --> normaly is this the center of the sample freuency
				int		 FrqLocked:2;	//=16:32	1= the frequency is locked, the  +/- NCOPosFreq is active
				UINT	 lastPlayFrq;	//=12:		the Frquency of a playing IQ-File - the FrqLocked is now aktiv too
				BYTE	 reserve[8];	//=8:
}RTL_PARA;


typedef struct	{
				//extern I/Q-Receiver for parorama view and width band scanning 
				UINT		IQ_type:8;		//type of the I/Q-Receiver --> ExtIO_TYPE_?...
				UINT		IQ_mode:3;		//the pointer to RTLPara.SampleSets[IQ_mode] (sample mode, is normal complex, but can be real too)
				UINT		IQ_soundcard:1; //the rx use soundcard
				UINT		IQ_SNDinType:1;	//0=microphone 1 = line input
				UINT		IQ_att:1;		//att exist
				UINT		IQ_agc:1;		//agc exist
				UINT		IQ_pre:1;		//preamplifier exist
				UINT		IQ_dit:1;		//IF dittering exist
				UINT		IQ_nb:1;		//IF nois blanker exist
				UINT		IQ_filter:1;	//band filter switch exist 
				UINT		IQ_reset:1;		//force a restart
				UINT		IQ_default:1;	//reset to default data
				UINT		IQ_onoff:1;		//RX-Receiver ON / OFF  0=OFF 1=ON
				UINT		IQ_open:1;		//if RX-Receiver is open, then this flag is 1, else this flag is 0
				UINT		IQ_swap:1;		//if swap the channel of I/Q input
				UINT		IQ_showGUI:1;	//the GUI show status
				UINT		IQ_showGUIex:1;	//force show or hide explicitly
				UINT		m_att:1;		//state of att on/off
				UINT		m_agc:1;		//state of agc on/off
				UINT		m_pre:1;		//state of att preamplifier on/off
				UINT		m_dit:1;		//state of IF dittering on/off
				UINT		m_nb:1;			//state of IF nois blanker on/off
				UINT		IQ_DCcorr:1;	//use I/Q DC correction

				//calibration parameter
				short		dBLevelOffset;	//dBm bottom level correcture
				short		XtalFrqCorr;	//Xtal frequency correcture
				short		XtalScalingCorr;//Xtal frequency scaling correcture
				USHORT		IQ_noSampleSelect:1;//do not built a SampleMenu - ExtIO-DLL Call SetSample not exist
				USHORT		IQ_HFGain:1;	//HFgain exist
				USHORT		IQ_IFGain:1;	//IFgain exist
				USHORT		m_afc:1;		//if 1 then, an mouse click snapp to the center frequency
				USHORT		m_mw_steps:2;	//if 1 use for mouse wheel full sample rate 2= 3=
				USHORT		IQ_noAccess:1;	//conditionally permitted - compromised access
				USHORT		IQruns:1;		//this radio thread is running
				USHORT		RDS:2;			//WFM RDS Stereo System  0=OFF, >0 == 1=RDS RadioText 2=ProgramText 3=Both
				USHORT		OpenStatus:2;	//0=device ON, 1=device OFF, 2=open error, 3=device removed   
				USHORT		VHFwmf:1;		//VHF radio = radiofrq>86000000 && radiofrq<110000000 and MODE_WMF
				USHORT		useInternAnt:1;	//do not use the extern VHF/UHF Antenna, use only the intern SW-Antenna as VHF/UHF Input
				USHORT		ureserve:2;
				BYTE		m_filter;
				HWND		IQ_Dialog;		//the handle to the extern IO dialog for message conmunication
				UINT		HFGain:5;		//(UINT) HFgain (Attenuation) as -1 dB Steps max=31 
				UINT		IFGain:6;		//(UINT) IFgain as +1 dB Steps 
				int			IQ_ceOffset:21;	//offset from decoder center (normal=0  for  +/- 12 kHz default IF-Center cut of the panorama window)
				char		IQ_DLLname[16]; //max 16 chars of the name of the ExtIO_??????.DLL 	
				char		IQ_SNDname[32]; //max 32 chars of the soundcard name 
				RTL_PARA	RTLPara;
				}EXT_IQRX;

#ifndef defRIFFILELIST
#define defRIFFILELIST
typedef	struct	{
				char		shortname[64];
				char		tooltip[64];
				char		filename[256];
				char		IQ_info;
				char		workflag;
				char		modename[4];
				double		frq;
				UINT		type;
				UINT		mode;
				int			bits;
				int			samples;
				UINT		nChannels;
				time_t		fileTime;
				UINT		fileLenght;
				}RIFFILELIST;
typedef CArray<RIFFILELIST,RIFFILELIST&> RIFFileArray;
#endif

typedef struct
				{
				char		A3[4];
				char		A2[4];
				char		Name[50];
				int			Number;
				int			sort;
				int			item;
				}ISOCODE_A;
typedef	CArray<ISOCODE_A,ISOCODE_A&> IsoList;

typedef struct	{
				char			name[32];
				int				type;	    //0=MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE; 1=MIXERLINE_COMPONENTTYPE_SRC_LINE
 				}IN_DEVICE_INFO;
typedef CArray<IN_DEVICE_INFO,IN_DEVICE_INFO&> InDeviceList;


#define IF_STYLE_LIN		0x00000000	//line spectrum 
#define IF_STYLE_ANA		0x00000100	//filled spectrum 
#define IF_STYLE_SCP		0x00000200	//scope style
#define IF_STYLE_3DL		0x00000400	//line stile as 3D landscape
#define IF_STYLE_TIH		0x00000800	//time sprectrum horizontal
#define IF_STYLE_TIV		0x00001000	//time sprectrum verticale
#define IF_STYLE_DEC		0x80000000	//scope style in Decibel

#define IF_STYLE_TOP_MAG	0x00000000	//top style magnitude
#define IF_STYLE_TOP_TIV	0x00002000	//top style time sprectrum
#define IF_STYLE_TOP_DEC	0x00004000	//top style in Decibel


#define IF_STYLE_MASK		0x0FFFFFFF	//spectrum style mask 


//DRM STATE
#define	DRM_STATE_MASK			0x000F
#define	DRM_SIGLEV_CHANGES		0x8000

#define	DRM_STATE_NOT_PRESENT	0x0000
#define	DRM_STATE_CRC_ERROR		0x0001
#define	DRM_STATE_DATA_ERROR	0x0002
#define	DRM_STATE_RX_OK			0x0003

#define	DRM_MSC_NOT_PRESENT		0x0100
#define	DRM_MSC_CRC_ERROR		0x0101
#define	DRM_MSC_DATA_ERROR		0x0102
#define	DRM_MSC_STATE_RX_OK		0x0103

#define	DRM_SDC_NOT_PRESENT		0x0200
#define	DRM_SDC_CRC_ERROR		0x0201
#define	DRM_SDC_DATA_ERROR		0x0202
#define	DRM_SDC_STATE_RX_OK		0x0203

#define	DRM_FAC_NOT_PRESENT		0x0400
#define	DRM_FAC_CRC_ERROR		0x0401
#define	DRM_FAC_DATA_ERROR		0x0402
#define	DRM_FAC_STATE_RX_OK		0x0403

#define	DRM_FSYNC_NOT_PRESENT	0x0800
#define	DRM_FSYNC_CRC_ERROR		0x0801
#define	DRM_FSYNC_DATA_ERROR	0x0802
#define	DRM_FSYNC_STATE_RX_OK	0x0803

#define	DRM_TYSNC_NOT_PRESENT	0x1000
#define	DRM_TYSNC_CRC_ERROR		0x1001
#define	DRM_TYSNC_DATA_ERROR	0x1002
#define	DRM_TYSNC_STATE_RX_OK	0x1003

#define	DRM_IO_NOT_PRESENT		0x2000
#define	DRM_IO_CRC_ERROR		0x2001
#define	DRM_IO_DATA_ERROR		0x2002
#define	DRM_IO_STATE_RX_OK		0x2003


extern	COLORPACK mCOL;

#define  COL_BACK			mCOL.background
#define  COL_KNOBFACE		mCOL.knobface
#define  myLIGHT			mCOL.light
#define  myVLIGHT			mCOL.vlight
#define  myDARK				mCOL.dark
#define  myVDARK			mCOL.vdark
#define  COL_BTXT			mCOL.btxt

#define  COL_SCOPEMARK		mCOL.scopemark
#define  COL_SCOPE_B		mCOL.scope_B
#define  COL_SCOPE_L		mCOL.scope_L
#define  COL_SCOPE_P		mCOL.scope_P
#define  COL_SCOPE_LINE		mCOL.scope_line

////////////////////////////////////////
//////////////// this is the first call 
/////////////////////////////////////////
//OpenReceiver, if PID==0 then get the next best
//----------------------------------------------------------------------------------------------------------------------------------
// !!!!prepare for the MainDialog.m_hWnd this must be all times the first action 
typedef BOOL	(WINAPI *DLL_OpenReceiver)(HWND mainwnd, char *maindir, UINT PID);
typedef void	(WINAPI *DLL_ProcessIFInput)(int process, WPARAM wp, LPARAM lp);	// the IF input message WM_PROCESS_IFIN will be processed by this App 
extern IFJet1102DLLThread *m_IFinpuThread;
extern volatile int		 IFinpuThreadWorkFlag;
extern volatile int		 IQinpuThreadWorkFlag;

typedef void	(WINAPI *DLL_CloseAll)();												//close Radio- and Audio- Device	

typedef int		(WINAPI *DLL_SetInputChannel)(int set);									//set the HI/LO Channel or automatic 
typedef int		(WINAPI *DLL_CheckDeviceChangings)(UINT nEventType, DWORD dwData);		//check device changings by message OnDeviceChange

typedef int		(WINAPI *DLL_SetRadioFrq)(int frq);						//set the radio frequency in Hz
typedef void	(WINAPI *DLL_SetRadioATT)(int att);						//set the radio attenuator (ON/OFF)
typedef void	(WINAPI *DLL_SetRadioIGC)(int igc);						//set the audio atomatic IF gain control 0-15 from fast to slow decay/attack
typedef void	(WINAPI *DLL_SetRadioIF)(int IF);						//set the radio filter band width
typedef void	(WINAPI *DLL_SetRadioMode)(int mode);					//set the radio demodulator mode LSB,USB,AM,FM...
typedef void	(WINAPI *DLL_SetRadioVolume)(int vol, int reset);		//set the radio volume 0-200; if reset=1 the reset the IGC Funktion
typedef int		(WINAPI *DLL_SetRadioSquelch)(int sql);					//set the radio squelch 0-160;

typedef void	(WINAPI *DLL_SetRadioFrqCorr)(int Hz,int onoff);		//set the Si570 Xtal-Frequency correcture in Hz
typedef void	(WINAPI *DLL_SetRadioFrqScale)(int Hz,int onoff);		//set the Si570 Xtal-Frequency Scale in Hz
typedef void	(WINAPI *DLL_SetDXFactor)(int factor,int onoff);		//set the DX-Gain Factor of the DX-Channel
typedef void	(WINAPI *DLL_SetAudioSampleCorr)(int ppm,int onoff);	//set the adio sample freqency corrction in ppm  
typedef UINT	(WINAPI *DLL_GetEEpromInfo)(RJ10_EEROM_INFO *info);		//read the EEprom and create viewlable information
typedef int		(WINAPI *DLL_HandleEEpromValue)(int type, int set);		//Read, Write or Check the EEprom Data	
typedef int		(WINAPI *DLL_HandleRadioValue)(int type, int set);		//Set or Get radio parameter 
typedef void	(WINAPI *DLL_SetCalibrationMark)(int set);				//set an calibration signal in dBm, set a positive value, we set this to negative value
typedef void	(WINAPI *DLL_SetCalibrationLine)(int set);				//switch the DoubleLines-Input on/off --> for two calibration signal lines

typedef BOOL	(WINAPI *DLL_OpenIFInput)(HWND audioin, DWORD IFJet1102DLLThread_ID);	//Open IF Input with your audio messages window and backprocess
typedef void	(WINAPI *DLL_ActivateIFInput)(int onOff);								//reactivate or deactivate IF Input after an device removement 0=reactivate 1=deactivate
typedef BOOL	(WINAPI *DLL_OpenAFOutput)(HWND audioout, char *name,  HWND DecEndWindow);	//Open AF Output with your audio messages window and as option the TX/RX decoder Window
typedef LRESULT	(WINAPI *DLL_MixerChange)(WPARAM hMixer,LPARAM dwControlID);//the routine for the IF-Input/Audio-Mixer handling

//#define SetMainVolume(level)			SetSpeakerVolume(-1,level)
#define SetWaveOutLeftLevel(level)		SetSpeakerVolume(-2,level)
#define SetWaveOutRightLevel(level)		SetSpeakerVolume(-3,level)
#define SetWaveOutMainLevel(level)		SetSpeakerVolume(-4,level)

typedef void	(WINAPI *DLL_SetSpeakerVolume)(int chn, int vol);	//set the main speaker volume 0-200; chn = 0=left and 1=right -1 = main
typedef void	(WINAPI *DLL_SetSpeakerOnOff)(int onof);			//switch for the main speaker off = -2 or on = -1  (0-4 intern specials --> see the decription on internet)
typedef void	(WINAPI *DLL_SetStereoOnOff)(int onof);				//switch the AudioOut to Stereo (only for DRM mode)
typedef void	(WINAPI *DLL_SetListenOn)();						//switch to listen / unfiltered input sound
typedef void	(WINAPI *DLL_SetWaveInLevel)(int lev);				//set the wave in level 0-200;
typedef void	(WINAPI *DLL_SetWaveOutVolume)(int vol);			//set the wave out volume 0-200;
typedef void	(WINAPI *DLL_SetWaveOn)();							//switch to wave / filtered output sound
typedef int 	(WINAPI *DLL_SetIFInputLevel)(int lev, int onOFF);	//set the IF-Input level and the currend onOFF state
typedef int 	(WINAPI *DLL_SetIFOutputLevel)(int lev);			//set the IF-Output level 0-200;

typedef float	(WINAPI *DLL_GetIFDrawData)(IF_DRAW_PARA *GetPara, int channel);	//get all the plot data and parameter of the current IF-Signal, -1 = default = current channel

typedef void	(WINAPI *DLL_DrawPotiLayout)(POTI_DRAWINFO *pinfo);		//draw poti design
typedef void	(WINAPI *DLL_InitRJ10Colors)(COLORPACK *colPack);		//init the RJ10 color design 

typedef BOOL    (WINAPI *DLL_OpenExtIQ)(EXT_IQRX *extRX);				//open the extern I/Q receiver for panorama view
typedef BOOL    (WINAPI *DLL_CloseExtIQ)();								//close the extern I/Q receiver 
typedef float	(WINAPI *DLL_GetExtIQDrawData)(IQ_DRAW_PARA *GetPara);	//get all the plot data and parameter of the current extern I/Q-Signal
typedef void	(WINAPI *DLL_SetExtIQData)(EXT_IQRX *extRX);			//set calibration data for the extern I/Q receiver (dBLevelOffset,XtalFrqCorr,XtalScalingCorr...)
typedef void	(WINAPI *DLL_PepareExtIQDataSet)(EXT_IQRX *extRX);		//you set the the IQ_type in EXT_IQRX data set,then call PepareExtIQDataSet 
																		//set befor extRX->IQ_type and if you set extRX->IQ_default=1 then you load a default set

//RIF = Radio Intermediate Frequency Files / in this case only for panorama view IQ data (for broad spectrum, but much less phase resolution)
typedef int		(WINAPI *DLL_IQ_Play)(char *filename, HWND RequestWindow, BOOL loop);   //play an RIF-File, like IF-Input
typedef void	(WINAPI *DLL_IQ_StopPlay)();						//stop playing and close the RIF-File
typedef BOOL	(WINAPI *DLL_IQ_Record)(char *filename, HWND RequestWindow); //record IF-Input to the RIF-File
typedef void	(WINAPI *DLL_IQ_StopRecord)();						//stop recording and close the RIF-File
typedef UINT	(WINAPI *DLL_IQ_GetPlayFileInfo)(char *filename,WAVEFORMATEX *fmt);		//Open RIF-File only for Info (no playing) / fmt->nChannels must be set / returned the FileLenght
typedef LONG	(WINAPI *DLL_IQ_SeekCurPlayFile)(LONG diff);		//seek on current position + diff
typedef LONG	(WINAPI *DLL_IQ_SeekSetPlayFile)(LONG pos);			//seek definitive on position
typedef UINT	(WINAPI *DLL_IQ_GetPlayFileLenght)();				//get the lenght of the currend open RIF-Record file
typedef void	(WINAPI *DLL_IQ_HaltPlay)(int state);				//set the Play halt state of the currend open RIF-Record file		1=halt 0=run
typedef void	(WINAPI *DLL_IQ_HaltRec)(int state);				//set the Record halt state of the currend open RIF-Record file		1=halt 0=run
typedef void	(WINAPI *DLL_IQ_LoopPlay)(int state);				//set the Play loop state of the currend open RIF-Record file		1=play continue 0=single times

//for DRM-Status
typedef IsoList		 &(WINAPI *DLL_GetLanguageList)();				//get the address pointer of the LanguageTable
typedef IsoList		 &(WINAPI *DLL_GetCountryList)();				//get the address pointer of the CountryTable
typedef CStringArray &(WINAPI *DLL_GetRegionsList)();				//get the address pointer of the RegionsList StringArray
typedef CStringArray &(WINAPI *DLL_GetDataAudioTypeList)();			//get the address pointer of the DataAudioTypes StringArray
typedef CStringArray &(WINAPI *DLL_GetCodecTypeList)();				//get the address pointer of the CodecTypes StringArray
typedef CStringArray &(WINAPI *DLL_GetProgramTypeList)();			//get the address pointer of the ProgramTypes  
typedef InDeviceList &(WINAPI *DLL_GetInputDeviceList)();			//get the address pointer of the Audio Device List 
typedef void (WINAPI *DLL_CopyRxStatus)(RX_SIGNAL_STATE *State, int readNew);	//get the DRM status info

extern HINSTANCE				m_DllHandle;

extern DLL_ProcessIFInput		ProcessIFInput;	
extern DLL_OpenReceiver			OpenReceiver;
extern DLL_CloseAll				CloseAll;
extern DLL_SetInputChannel		SetInputChannel;
extern DLL_CheckDeviceChangings	CheckDeviceChangings;

extern DLL_SetRadioFrq			SetRadioFrq;
extern DLL_SetRadioATT			SetRadioATT;
extern DLL_SetRadioIF			SetRadioIF;
extern DLL_SetRadioVolume		SetRadioVolume;
extern DLL_SetRadioSquelch		SetRadioSquelch;
extern DLL_SetRadioIGC			SetRadioIGC;
extern DLL_SetRadioMode			SetRadioMode;

extern DLL_SetRadioFrqCorr		SetRadioFrqCorr;
extern DLL_SetRadioFrqScale		SetRadioFrqScale;
extern DLL_SetDXFactor			SetDXFactor;
extern DLL_SetAudioSampleCorr	SetAudioSampleCorr;
extern DLL_GetEEpromInfo		GetEEpromInfo;
extern DLL_HandleEEpromValue	HandleEEpromValue;
extern DLL_HandleRadioValue		HandleRadioValue;
extern DLL_SetCalibrationMark	SetCalibrationMark;
extern DLL_SetCalibrationLine	SetCalibrationLine;

extern DLL_OpenIFInput			OpenIFInput;
extern DLL_ActivateIFInput		ActivateIFInput;
extern DLL_OpenAFOutput			OpenAFOutput;
extern DLL_MixerChange			MixerChange;

extern DLL_SetSpeakerVolume		SetSpeakerVolume;
extern DLL_SetSpeakerOnOff		SetSpeakerOnOff;
extern DLL_SetStereoOnOff		SetStereoOnOff;
extern DLL_SetListenOn			SetListenOn;
extern DLL_SetWaveInLevel		SetWaveInLevel;
extern DLL_SetWaveOutVolume		SetWaveOutVolume;
extern DLL_SetWaveOn			SetWaveOn;
extern DLL_SetIFInputLevel		SetIFInputLevel;
extern DLL_SetIFOutputLevel		SetIFOutputLevel;

extern DLL_GetIFDrawData		GetIFDrawData;
extern DLL_DrawPotiLayout		DrawPotiLayout;
extern DLL_InitRJ10Colors		InitRJ10Colors;

extern DLL_OpenExtIQ			OpenExtIQ;
extern DLL_CloseExtIQ			CloseExtIQ;
extern DLL_GetExtIQDrawData		GetExtIQDrawData;
extern DLL_SetExtIQData			SetExtIQData;
extern DLL_PepareExtIQDataSet	PepareExtIQDataSet;

extern DLL_IQ_Play				IQ_Play;
extern DLL_IQ_StopPlay			IQ_StopPlay;
extern DLL_IQ_Record			IQ_Record;
extern DLL_IQ_StopRecord		IQ_StopRecord;
extern DLL_IQ_GetPlayFileInfo	IQ_GetPlayFileInfo;
extern DLL_IQ_SeekCurPlayFile	IQ_SeekCurPlayFile;
extern DLL_IQ_SeekSetPlayFile	IQ_SeekSetPlayFile;
extern DLL_IQ_GetPlayFileLenght	IQ_GetPlayFileLenght;
extern DLL_IQ_HaltPlay     		IQ_HaltPlay;
extern DLL_IQ_HaltRec			IQ_HaltRec;
extern DLL_IQ_LoopPlay     		IQ_LoopPlay;

extern DLL_GetLanguageList		GetLanguageList;
extern DLL_GetCountryList		GetCountryList;
extern DLL_GetProgramTypeList	GetProgramTypeList;
extern DLL_GetDataAudioTypeList GetDataAudioTypeList;
extern DLL_GetCodecTypeList		GetCodecTypeList;
extern DLL_GetRegionsList		GetRegionsList;
extern DLL_GetInputDeviceList	GetInputDeviceList;
extern DLL_CopyRxStatus			CopyRxStatus;

//specific definition of lists and files
#define myLanguage				GetLanguageList()
#define myCountries				GetCountryList()
#define myRegionsList			GetRegionsList()
#define myProgramTypes			GetProgramTypeList()
#define myDataAudioTypes		GetDataAudioTypeList()
#define myCodecTypes			GetCodecTypeList()


extern char myDIR[256];

void	WINAPI DeInstall_RJ10MDLL();
BOOL	WINAPI Install_RJ10MDLL();
void	WINAPI Suspend_RJ10MDLL();



#pragma pack(pop)
#endif //#define FIFI_RJ10_DLL_ADAPTION